/*

		Copyright (c) 2009-2010 SMSC. All rights reserved.


	The information contained in this file is confidential and proprietary to
	Standard Microsystems Corporation.	No part of this file may be reproduced
	or distributed, in any form or by any means for any purpose, without the
	express written permission of Standard Microsystems Corporation.


Module Name:   SMSC7500.c

--*/


#include "smsc7500.h"

#include <Pkfuncs.h> 

#ifdef DEBUG
DBGPARAM dpCurSettings = { TEXT("LAN7500"), {
  TEXT("Undefined"),  TEXT("Undefined"), TEXT("Undefined"), TEXT("Undefined"),
  TEXT("Undefined"),  TEXT("Undefined"), TEXT("Undefined"), TEXT("Undefined"),
  TEXT("Undefined"),  TEXT("Undefined"), TEXT("Undefined"), TEXT("Undefined"),
  TEXT("Undefined"),  TEXT("Undefined"), TEXT("Undefined"), TEXT("Undefined") },
			   0x00000000 };
#endif

MP_GLOBAL_DATA	GlobalData={FALSE,FALSE,0,0};
NDIS_HANDLE NdisWrapperHandle;

typedef struct _REG_VALUES_DESCR {
   LPWSTR val_name;
   DWORD  val_type;
   PBYTE  val_data;
} REG_VALUES_DESCR, * PREG_VALUES_DESCR;

REG_VALUES_DESCR ParmKeyVal[] = {
   (TEXT("NdisLoadedBothWell")), REG_DWORD, (PBYTE)1,
	NULL, 0, NULL
};

PREG_VALUES_DESCR ParaVal[] = {
	ParmKeyVal,
};

LPWSTR ParaKeyName[] = { 
	(TEXT("SMSCBothWell")),    
};

/* ++

Routine Description:
 
	Change the value of a specified key to the registry under HKEY_LOCAL_MACHINE
	
Arguments:

		KeyName    The key's name you want to change the value.
		Vals			The value of the key
		
Return Value:

	TRUE   If Success
	False	 If there is an error
	
-- */
BOOL
ChangeKeyValues(
	LPWSTR KeyName,
	PREG_VALUES_DESCR Vals
	)
{
	DWORD Status;
	DWORD dwDisp;
	HKEY hKey;
	PREG_VALUES_DESCR pValue;
	DWORD ValLen;
	PBYTE pVal;
	DWORD dwVal;
	LPWSTR pStr;

	Status = RegOpenKeyEx(
				 HKEY_LOCAL_MACHINE,
				 KeyName,
				 0,
				 0,
				 &hKey);

	if (Status != ERROR_SUCCESS) {
		return FALSE;
	}

	pValue = Vals;
	dwDisp = 0x00;

	while (pValue->val_name) {
		switch (pValue->val_type) {
		case REG_DWORD:
			pVal = (PBYTE)&dwVal;
			dwVal = (DWORD)pValue->val_data;
			ValLen = sizeof(DWORD);
			break;

		case REG_SZ:
			pVal = (PBYTE)pValue->val_data;
			ValLen = (wcslen((LPWSTR)pVal) + 1)*sizeof(WCHAR);
			break;

		case REG_MULTI_SZ:
			pStr = (LPWSTR)pValue->val_data;
			dwVal = 0;
			while (*pStr) {
				dwDisp += wcslen(pStr) + 1;
				dwVal += dwDisp;
				pStr += dwDisp;
			}
			dwVal++;

			ValLen = dwVal*sizeof(WCHAR);
			pVal = pValue->val_data;
			break;
		}

		
		Status = RegSetValueEx(
					 hKey,
					 pValue->val_name,
					 0,
					 pValue->val_type,
					 pVal,
					 ValLen
					 );
		if (Status != ERROR_SUCCESS) {
			RegCloseKey(hKey);
			return FALSE;
		}
		else {
			SMSC_TRACE3(DBG_INIT,"Set Register key %s. %s  %d \r\n",KeyName,pValue->val_name,*pVal);
		}
		pValue++;
	}
	RegCloseKey(hKey);
	return TRUE;
}	


/* ++

Routine Description:   
	Query the value of a specified key to the registry under HKEY_LOCAL_MACHINE
	
Arguments:

		KeyName    The key's name you want to query.
		Vals			the return value of the key
		
Return Value:

	return the value of the specified key
	
-- */
DWORD
QueryKeyValues(
	LPWSTR KeyName,
	PREG_VALUES_DESCR Vals
	)
{
	DWORD Status;
	DWORD dwDisp;
	HKEY hKey;
	PREG_VALUES_DESCR pValue;
	DWORD ValLen;
	PBYTE pVal;
	DWORD dwVal;
	LPWSTR pStr;

	
	Status = RegOpenKeyEx(
				 HKEY_LOCAL_MACHINE,
				 KeyName,
				 0,
				 0,
				 &hKey);
	

	if (Status != ERROR_SUCCESS) {
		SMSC_TRACE0(DBG_ERROR,"SMSC: open key fail\r\n");
		return FALSE;
	}

	pValue = Vals;
	dwDisp = 0x00;

 
	switch (pValue->val_type) {
		case REG_DWORD:
			pVal = (PBYTE)&dwVal;
			dwVal = (DWORD)pValue->val_data;
			ValLen = sizeof(DWORD);
			break;

		case REG_SZ:
			pVal = (PBYTE)pValue->val_data;
			ValLen = (wcslen((LPWSTR)pVal) + 1)*sizeof(WCHAR);
			break;

		case REG_MULTI_SZ:
			pStr = (LPWSTR)pValue->val_data;
			dwVal = 0;
			while (*pStr) {
				dwDisp += wcslen(pStr) + 1;
				dwVal += dwDisp;
				pStr += dwDisp;
			}
			dwVal++;

			ValLen = dwVal*sizeof(WCHAR);
			pVal = pValue->val_data;
			break;
	}
		
	Status = RegQueryValueEx(
					 hKey,
					 pValue->val_name,
					 NULL,
					 &pValue->val_type,
					 pVal,
					 &ValLen
					 );
	if (Status != ERROR_SUCCESS) {
		RegCloseKey(hKey);
		SMSC_TRACE0(DBG_ERROR,"Query Register key Failed\r\n");
		return FALSE;
	}
//	else {
//		SMSC_TRACE3(DBG_INIT,"Query Register key %s. %s  %d \r\n",KeyName,pValue->val_name,*(pVal));
//	}
 
	RegCloseKey(hKey);
 
	return *(pVal);
}	// AddKeyValues


/*++

 Routine Description:

	Standard Windows DLL entrypoint.  Since Windows CE NDIS miniports are implemented
	as DLLs, a DLL entrypoint is needed.

Arguments:

Return Value:

--*/
BOOL
DllEntry(
   HANDLE hDllHandle,
   DWORD  dwReason,
   LPVOID lpreserved
   )
{
	UNREFERENCED_PARAMETER(hDllHandle);
	UNREFERENCED_PARAMETER(lpreserved);

	switch (dwReason) {

	  case DLL_PROCESS_ATTACH:
		   DEBUGREGISTER((HINSTANCE)hDllHandle);
	   	   DisableThreadLibraryCalls((HMODULE) hDllHandle);
		   InitializeCriticalSection (&GlobalData.Access_Instance);
		   SMSC_TRACE0(DBG_INIT,"-->DllEntry get called\r\n");
		   break;

	  case DLL_PROCESS_DETACH:
           DeleteCriticalSection(&GlobalData.Access_Instance);
	  	   SMSC_TRACE0(DBG_INIT,"<--DllEntry get unloaded\r\n");
		   break;

	  default:
		break;
	}

	return TRUE;
}


/*++
Routine Description:

	In the context of its DriverEntry function, a miniport driver associates
		itself with NDIS, specifies the NDIS version that it is using, and 
		registers its entry points. 


Arguments:
		DriverObject - pointer to the driver object. 
		RegistryPath - pointer to the driver registry path.
		
Return Value:
	
		NDIS_STATUS_xxx code

Note: If the device is not attached, it just returns UNSUCCESSFUL; it will be called again after the USB device is attached 
		 and  the NdisRegisterAdapter() is called in the USBDeviceAttach() function.
--*/
NDIS_STATUS 
DriverEntry (IN PDRIVER_OBJECT DriverObject,
			  IN PUNICODE_STRING RegistryPath)
{

	NDIS_MINIPORT_CHARACTERISTICS Characteristics;
	NDIS_STATUS Status;
	int i=0;

    RETAILMSG(1, (TEXT("SMSC7500 V1.0 \r\n")));
    
	SMSC_TRACE0(DBG_INIT,"-->DriverEntry\r\n");
	
	#ifdef USE_INT_PIPE
	SMSC_TRACE0(DBG_INIT, "Using Interrupt Endpoint.\r\n");
	#endif

	#ifdef BIDIMENSIONAL_SEND_LIST
	SMSC_TRACE0(DBG_INIT, "Using BIDIMENSIONAL_SEND_LIST.\r\n");
	#endif

	#ifdef USE_THREAD
	SMSC_TRACE0(DBG_INIT, "Using Thread.\r\n");
	#endif

	#ifdef USE_WORK_ITEM_NO_OUT
	SMSC_TRACE0(DBG_INIT, "Using Work Item No return.\r\n");
	#endif

	#ifdef USE_WORK_ITEM_RESUBMIT_RCB
	SMSC_TRACE0(DBG_INIT, "USE_WORK_ITEM_RESUBMIT_RCB\r\n");
	#endif

	if (!GlobalData.DeviceAttached)
	{
		SMSC_TRACE0(DBG_INIT, "Device is not attached yet!!!, Return UNSUCCESSFUL\r\n");
		for (i = 0; i < (sizeof(ParaKeyName)/sizeof(LPWSTR)); i++) {
			   if (!ChangeKeyValues(ParaKeyName[i], ParaVal[i])) {
					SMSC_TRACE0(DBG_ERROR,"Register key failed. \r\n");
				}
		
		}
		SMSC_TRACE0(DBG_INIT,"<--DriverEntry\r\n");
		return STATUS_UNSUCCESSFUL;
	}

	if (GlobalData.DriverEntryInit)
	{
		SMSC_TRACE0(DBG_INIT, "DriverEntry Already Initialized Once!!! Return FAILURE\r\n");
		return NDIS_STATUS_FAILURE;
	}

	NdisMInitializeWrapper(&NdisWrapperHandle, DriverObject, RegistryPath, NULL);

	if (!NdisWrapperHandle)
	{
		SMSC_TRACE0(DBG_ERROR,"NdisMInitializeWrapper failed, Return FAILURE\r\n");
		 return NDIS_STATUS_FAILURE;
	}

	
	NdisZeroMemory (&Characteristics, sizeof (Characteristics));

	Characteristics.MajorNdisVersion = (UCHAR)SMSC7500_NDIS_MAJOR_VERSION;
	Characteristics.MinorNdisVersion = (UCHAR)SMSC7500_NDIS_MINOR_VERSION;
	Characteristics.CheckForHangHandler = MPCheckForHang;
	Characteristics.DisableInterruptHandler = NULL;
	Characteristics.EnableInterruptHandler = NULL;
	Characteristics.HaltHandler = MPHalt;
	Characteristics.InitializeHandler =MPInitialize;
	Characteristics.SetInformationHandler	  = MPSetInformation;
	Characteristics.QueryInformationHandler   = MPQueryInformation;
	Characteristics.ReconfigureHandler = NULL;
	Characteristics.ResetHandler = MPReset;
	Characteristics.SendHandler = NULL;
	Characteristics.TransferDataHandler = NULL;
	Characteristics.ReturnPacketHandler = MPReturnPacket;
	Characteristics.SendPacketsHandler = MPSendPackets;
	Characteristics.AllocateCompleteHandler = NULL;

	Status = NdisMRegisterMiniport(NdisWrapperHandle,
									&Characteristics,
									sizeof(NDIS_MINIPORT_CHARACTERISTICS));

	if (Status == NDIS_STATUS_SUCCESS)
	{
		SMSC_TRACE0(DBG_INIT, "NdisMRegisterMiniport OK.\r\n");
	}
	else
	{
		// Terminate the wrapper.
		NdisTerminateWrapper (NdisWrapperHandle, NULL);
		NdisWrapperHandle = NULL;
		SMSC_TRACE1(DBG_ERROR,"	NdisMRegisterMiniport failed .Status= 0x%x\r\n",Status);
		return NDIS_STATUS_FAILURE;
	}

	GetDriverInfo();
	GlobalData.DriverEntryInit=TRUE;
	
	SMSC_TRACE0(DBG_INIT,"<--DriverEntry, return NDIS_STATUS_SUCCESS\r\n");

	return NDIS_STATUS_SUCCESS;
}

/*++
 
 Routine Description:
		USB driver install routine - set up client registry settings so we will be loaded
		by USBD. 

Arguments:

Return value:
		Return TRUE if install succeeds, or FALSE if there is some error.
 --*/

BOOL
USBInstallDriver(
   LPCWSTR szDriverLibFile
   )
{
	BOOL  bRc;
   

	const WCHAR wsUsbDeviceID[] = CLASS_NAME_SZ;
	WCHAR wsSubClassRegKey[sizeof(CLIENT_REGKEY_SZ)+16] = CLIENT_REGKEY_SZ;

	USB_DRIVER_SETTINGS usbDriverSettings = { SMSC7500_DRIVER_SETTINGS };

	REG_VALUE_DESCR usbKeyValues[] = {
		(TEXT("Dll")),				 REG_SZ,	0, (PBYTE)(DRIVER_NAME_SZ),
		(TEXT("Prefix")),			 REG_SZ,	0, (PBYTE)(DEVICE_PREFIX),
		NULL, 0, 0, NULL
	};

	SMSC_TRACE0(DBG_INIT,"-->USBInstallDriver\r\n");

	//
	// register with USBD
	//
	bRc = RegisterClientDriverID( wsUsbDeviceID );

	if ( !bRc ) {
		SMSC_TRACE0(DBG_ERROR,"Fail to RegisterClientDriverID\r\n");
		return FALSE;
	}

	bRc = RegisterClientSettings( szDriverLibFile,
								 wsUsbDeviceID,
								 NULL,
								 &usbDriverSettings );

	if ( !bRc ) {
		UnRegisterClientDriverID(wsUsbDeviceID);
		SMSC_TRACE0(DBG_ERROR,"Failed to RegisterClientSettings\r\n");
		return FALSE;
	}

	//
	// Add our default values to the reg
	//
	if ( !GetSetKeyValues( wsSubClassRegKey,
						   &usbKeyValues[0],
						   SET,
						   TRUE ) ) {
		SMSC_TRACE0(DBG_ERROR,"Failed to add our default values to the reg!\r\n");
		return FALSE;
	}


	SMSC_TRACE0(DBG_INIT,"<--USBInstallDriver\r\n");
	return bRc;
}


/*++
 Routine Description:
 
	This function can be called by a client driver to deregister itself with USBD.

 Arguments:
 
 Return value:
		 Return TRUE if Uninstall succeeds, or FALSE if there is some error.

 --*/
BOOL
USBUnInstallDriver(
   VOID
   )
{
	BOOL bRc;

	const WCHAR wsUsbDeviceID[] = CLASS_NAME_SZ;

	USB_DRIVER_SETTINGS usbDriverSettings = { SMSC7500_DRIVER_SETTINGS };

	SMSC_TRACE0(DBG_INIT,"-->USBUnInstallDriver\r\n");


	bRc = UnRegisterClientSettings( wsUsbDeviceID,
								   NULL,
								   &usbDriverSettings );

	bRc = bRc & UnRegisterClientDriverID( wsUsbDeviceID );

	SMSC_TRACE0(DBG_INIT,"<--USBUnInstallDriver\r\n");

	return bRc;
}


/*++
 Routine Description:
  
	 USB device attach routine.  This function is called by USBD when a device is attached
	 to the USB, and a matching registry key is found off the LoadClients registry key. 
	 We must determine whether the device may be controlled by this driver.

 Arguments:

 Return Value:
	 Return TRUE if success, or FALSE if an error occurs.
 --*/
BOOL
USBDeviceAttach(
   USB_HANDLE		hDevice,
   LPCUSB_FUNCS 	UsbFuncs,
   LPCUSB_INTERFACE UsbInterface,
   LPCWSTR			UniqueDriverId,
   LPBOOL			AcceptControl,
   LPCUSB_DRIVER_SETTINGS UsbDriverSettings,
   DWORD Unused
   )
{
	BOOL			 bRc = TRUE;
	ULONG			 ulConfigIndex = 0;
	PMP_ADAPTER   pUsbDevice = NULL;
	LPCUSB_INTERFACE pUsbInterface = NULL;
	UCHAR dwBmAttributes;
	int i=0;

	typedef struct {
					NDIS_STRING Name;		
					PULONG pValue;			
					NDIS_PARAMETER_TYPE Type;
				   } REGISTRY_ENTRY, *PREGISTRY_ENTRY;


	UNREFERENCED_PARAMETER(UniqueDriverId);
	UNREFERENCED_PARAMETER(Unused);
	UNREFERENCED_PARAMETER(UsbDriverSettings);

	SMSC_TRACE2(DBG_INIT,"-->In USBDeviceAttach(0x%x, %s)\r\n", hDevice, UniqueDriverId);

	//
	// Determine if we control this USB peripheral...
	//
	*AcceptControl = FALSE;

	do {
		//
		// Parse USB Descriptors
		//
		pUsbInterface = ParseUsbDescriptors( hDevice,
											 UsbFuncs,
											 UsbInterface,
											 (LPUSHORT)&ulConfigIndex,
											 &dwBmAttributes);

		if ( !pUsbInterface ) {
			SMSC_TRACE0(DBG_ERROR,"ParseUsbDescriptors failed!\r\n");
			bRc = FALSE;
			break;
		}

		//
		// we found a device, interface, & protocol we can control, so create our device context
		//
		pUsbDevice = (PMP_ADAPTER)LocalAlloc( LPTR, sizeof(MP_ADAPTER) );
		if ( !pUsbDevice ) {
			SMSC_TRACE1(DBG_ERROR,"LocalAlloc error:%d\r\n", GetLastError());
			bRc = FALSE;
			break;
		}

		SMSC_TRACE1(DBG_INIT,"pUsbDevice for USB %p\r\n",pUsbDevice);
		
				
		pUsbDevice->Sig = SMSC_SIG;
		pUsbDevice->hUsbDevice = hDevice;
		pUsbDevice->pUsbInterface = pUsbInterface;
		pUsbDevice->ConfigIndex   = (USHORT)ulConfigIndex;
		pUsbDevice->UsbFuncs = UsbFuncs;
		pUsbDevice->Dev_Flags.AcceptIo		= FALSE;
		pUsbDevice->Dev_Flags.DeviceRemoved = FALSE;

		//
		// set the USB interface/pipes
		//
		bRc = SetUsbInterface( pUsbDevice );

		if ( !bRc ) {
			SMSC_TRACE0(DBG_ERROR,"SetUsbInterface failed!\r\n");
			break;
		}

		USBDeviceOperationalSpeed(pUsbDevice);

		pUsbDevice->UsbDeviceSupportsWakes = (BOOLEAN)((dwBmAttributes & USB_CONFIG_REMOTE_WAKEUP) == USB_CONFIG_REMOTE_WAKEUP); 
		
		SMSC_TRACE1(DBG_INIT,"UsbDeviceSupportsWakes: %d \r\n", pUsbDevice->UsbDeviceSupportsWakes);

		bRc = UsbFuncs->lpRegisterNotificationRoutine( hDevice,
													   UsbDeviceNotify,
													   pUsbDevice );
		if ( !bRc ) {
			SMSC_TRACE1(DBG_ERROR,"RegisterNotificationRoutine error:%d\r\n", GetLastError());
			break;
		}

		pUsbDevice->Dev_Flags.AcceptIo		= TRUE;

		//In CE, the load order of the NDIS and USB stack are different from paltforms
		//use a flag in registry to wait the NDIS get load before we register an adapter to the NDIS.
		while(!QueryKeyValues(ParaKeyName[0],ParaVal[0]))
		{
//			SMSC_TRACE0(DBG_INIT,"waiting for NDIS Get Loaded \r\n");
			NdisMSleep(1);
		} 

		EnterCriticalSection (&GlobalData.Access_Instance);
		for (i=0;i<Num_of_Instances_supported;i++) {
		if (GlobalData.Instances[i]==0) {
			GlobalData.Instances[i]=1;
			GlobalData.Adapter[i]=pUsbDevice;
			pUsbDevice->InstanceName=pDeviceInstance[i];
			pUsbDevice->InstanceIndex=i;
			GlobalData.InstancesCount++;
			break;
			}
		}
		LeaveCriticalSection (&GlobalData.Access_Instance);
		
		if (i>=Num_of_Instances_supported) {
			SMSC_WARNING1("This driver only support %d instances, failed to Register Ndis\r\n",Num_of_Instances_supported);
			bRc = FALSE;
			break;
		}
		
		pUsbDevice->hNdisStartUpThread = CreateThread( NULL, 0,
												NdisStartUpThread,
												 pUsbDevice,
												 0, NULL );

	    
		if ( !pUsbDevice->hNdisStartUpThread) {
				bRc = FALSE;
				SMSC_TRACE1(DBG_ERROR,"CreateThread ERROR:%d\r\n", GetLastError());
				break;
		}

		SMSC_TRACE1(DBG_INIT,"USBDeviceAttach Pri:%d\r\n",
				CeGetThreadPriority(GetCurrentThread()));


		
		#ifdef USE_THREAD
					
				// This event is used to notify RecvThread task that there are new items in the RX completion list
				//
				pUsbDevice->RecvThreadEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
				if ( !pUsbDevice->RecvThreadEvent ) {
						break;
				}
				ResetEvent(pUsbDevice->RecvThreadEvent);
						
				pUsbDevice->hRecvThread = CreateThread( NULL, 0,RecvThread,pUsbDevice,0, NULL );
				if(!pUsbDevice->hRecvThread){
					SMSC_TRACE1(DBG_ERROR,"Create RecvThread ERROR:%d\r\n", GetLastError());
					break;
				}
		
		
				// This event is used to notify SendThread task that there are new items in the TX completion list
				//
				pUsbDevice->SendThreadEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
				if ( !pUsbDevice->SendThreadEvent ) {
					break;
				}
				ResetEvent(pUsbDevice->SendThreadEvent);
						
				pUsbDevice->hSendThread = CreateThread( NULL, 0,SendThread,pUsbDevice,0, NULL );
				if(!pUsbDevice->hSendThread){
					SMSC_TRACE1(DBG_ERROR,"Create SendThread ERROR:%d\r\n", GetLastError());
					break;
				}
		
						
		#endif
		
		#ifdef USE_WORK_ITEM_NO_OUT
				NdisInitializeWorkItem(&pUsbDevice->RecvWorkItem,
										RecvWorkItemCallBack,
										(PVOID)pUsbDevice);
				NdisInitializeEvent(&pUsbDevice->RecvWorkItemReady);
				NdisScheduleWorkItem(&pUsbDevice->RecvWorkItem);
					
					
				NdisInitializeWorkItem(&pUsbDevice->SendWorkItem,
										SendWorkItemCallBack,
										(PVOID)pUsbDevice);
				NdisInitializeEvent(&pUsbDevice->SendWorkItemReady);
				NdisScheduleWorkItem(&pUsbDevice->SendWorkItem);
		#endif	
		
		
		#ifdef USE_INT_PIPE
			#ifdef USE_THREAD
				// This event is used to notify SendThread task that there are new items in the Intscompletion list
				//
				pUsbDevice->IntThreadEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
				if ( !pUsbDevice->IntThreadEvent ) {
					break;
				}
				ResetEvent(pUsbDevice->IntThreadEvent);
						
				pUsbDevice->hIntThread = CreateThread( NULL, 0,IntThread,pUsbDevice,0, NULL );
				if(!pUsbDevice->hIntThread){
					SMSC_TRACE0(DBG_ERROR,"Create IntThread ERROR:%d\r\n", GetLastError());
					break;
				}
		
			#endif
		
					
			#ifdef USE_WORK_ITEM_NO_OUT
				NdisInitializeWorkItem(&pUsbDevice->IntsWorkItem,
										IntWorkItemCallback,
									   (PVOID)pUsbDevice);
				NdisInitializeEvent(&pUsbDevice->IntsWorkItemReady);
				NdisScheduleWorkItem(&pUsbDevice->IntsWorkItem);
					
			#endif
					
		#endif
		
	} while(0);



	if (!bRc) {
		//
		// If not our device, or error, then clean up
		//
//		GlobalData.DeviceAttached=FALSE; 
		if ( pUsbDevice) {
			pUsbDevice->Dev_Flags.AcceptIo = FALSE;
			MP_SET_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED);
			RemoveDeviceContext( pUsbDevice );
		}
		
	} else {

		*AcceptControl = TRUE;
		GlobalData.DeviceAttached=TRUE;
		MP_CLEAR_FLAG(pUsbDevice, fMP_DEVICE_NOT_ATTACHED);
		pUsbDevice->Dev_Flags.PipeClosed=0;

	}

	SMSC_TRACE2(DBG_INIT,"<--Out USBDeviceAttach:%d, %d\r\n", *AcceptControl, bRc );

	return bRc;
}

/*++
Routine Description:

	The MiniportInitialize function is a required function that sets up a
	NIC (or virtual NIC) for network I/O operations, claims all hardware
	resources necessary to the NIC in the registry, and allocates resources
	the driver needs to carry out network I/O operations.

	Arguments:

	Return Value:

	NDIS_STATUS_xxx code

--*/
NDIS_STATUS
MPInitialize(
	OUT PNDIS_STATUS OpenErrorStatus,
	OUT PUINT SelectedMediumIndex,
	IN PNDIS_MEDIUM MediumArray,
	IN UINT MediumArraySize,
	IN NDIS_HANDLE MiniportAdapterHandle,
	IN NDIS_HANDLE WrapperConfigurationContext)

{
	NDIS_HANDLE hConfigHandle;
	NDIS_STATUS 		Status = NDIS_STATUS_SUCCESS;
	PMP_ADAPTER 		Adapter=NULL;
	UINT				index;
    PNDIS_CONFIGURATION_PARAMETER  				ReturnedValue;
	DWORD dwInstanceIndex;
	NDIS_STRING InstanceIndex=NDIS_STRING_CONST("InstanceIndex");
  
    UNREFERENCED_PARAMETER(OpenErrorStatus);
		
	SMSC_TRACE0(DBG_INIT,"--> MPInitialize\r\n");

	NdisOpenConfiguration(&Status,&hConfigHandle, WrapperConfigurationContext);
	
	if (Status != NDIS_STATUS_SUCCESS)
    {
        SMSC_TRACE1(DBG_INIT," <-- MPInitialize, NdisOpenConfiguration failed 0x%x\r\n", Status);
        return NDIS_STATUS_RESOURCES;
    }
	else {
		SMSC_TRACE0(DBG_INIT,"  NdisOpenConfiguration success\r\n");
		}

	 //Read flow control flag.
    NdisReadConfiguration(
        &Status,
        &ReturnedValue,
        hConfigHandle,
        &InstanceIndex,
        NdisParameterHexInteger);
	 
    if (Status == NDIS_STATUS_SUCCESS) 
    {
    	SMSC_TRACE1(DBG_INIT,"  dwInstanceIndex %d\r\n", ReturnedValue->ParameterData.IntegerData);
        dwInstanceIndex=ReturnedValue->ParameterData.IntegerData;
	}
	else
	{
		SMSC_TRACE1(DBG_INIT,"<-- MPInitialize  NdisReadConfiguration failed 0x%x\r\n", Status);
		NdisCloseConfiguration (hConfigHandle);
        return NDIS_STATUS_FAILURE;
	}
	
	NdisCloseConfiguration (hConfigHandle);
	
	EnterCriticalSection (&GlobalData.Access_Instance);
	Adapter=GlobalData.Adapter[dwInstanceIndex-1];
	LeaveCriticalSection (&GlobalData.Access_Instance);

	
	SMSC_TRACE1(DBG_INIT,"Adapter for Ndis %p\r\n",Adapter);
	
	if (Adapter->RefCount)
	{
		SMSC_TRACE0(DBG_INIT, "MP initialized already!!!\r\n");
		Adapter->MPInitialized=TRUE;
		return NDIS_STATUS_FAILURE;
	}

	do {
		//
		// Check to see if our media type exists in an array of supported
		// media types provided by NDIS.
		//
		for(index = 0; index < MediumArraySize; ++index)
		{
			if(MediumArray[index] == NIC_MEDIA_TYPE) {
				break;
			}
		}

		if(index == MediumArraySize)
		{
			SMSC_TRACE0(DBG_ERROR,"Expected media is not in MediumArray.\r\n");
			Status = NDIS_STATUS_UNSUPPORTED_MEDIA;
			break;
		}

		//
		// Set the index value as the selected medium for our device.
		//
		*SelectedMediumIndex = index;

		Status = NICAllocAdapter(Adapter);
		if(Status != NDIS_STATUS_SUCCESS)
		{
			break;
		}

		MP_INC_REF(Adapter);

		MP_SET_FLAG(Adapter, fMP_INIT_IN_PROGRESS);
/*
		//
		// NdisMGetDeviceProperty function enables us to get the:
		// PDO - created by the bus driver to represent our device.
		// FDO - created by NDIS to represent our miniport as a function
		//				driver.
		// NextDeviceObject - deviceobject of another driver
		//						attached to us at the bottom.
		//

		NdisMGetDeviceProperty(MiniportAdapterHandle,
						   &Adapter->Pdo,
						   &Adapter->Fdo,
						   &Adapter->NextDeviceObject,
						   NULL,
						   NULL);
*/
		Adapter->AdapterHandle = MiniportAdapterHandle;

		// Save for later when we read the registry.
		Adapter->WrapperConfigurationContext = WrapperConfigurationContext;
	
		//
		// Inform NDIS about significant features of the NIC. A
		// MiniportInitialize function must call NdisMSetAttributesEx
		// (or NdisMSetAttributes) before calling any other NdisMRegisterXxx
		// or NdisXxx function that claims hardware resources. 
		// If this is NDIS51 miniport, it should use safe APIs. But if this
		// is NDIS 5.0, NDIS might assume that we are not using safe APIs
		// and try to map every send buffer MDLs. As a result, let us tell
		// NDIS, even though we are NDIS 5.0, we use safe buffer APIs by
		// setting the flag NDIS_ATTRIBUTE_USES_SAFE_BUFFER_APIS
		//
		NdisMSetAttributesEx(
			MiniportAdapterHandle,
			(NDIS_HANDLE) Adapter,
#ifdef SMSC_DBG
			40,		// We printed out so much stuff during the setpower OID
					// that we were timing out. Increase timeout to 10s so
					// so that we don't end up resetting in middle of setpower
#else
			10,
#endif
		
#ifdef NDIS50_MINIPORT
			NDIS_ATTRIBUTE_DESERIALIZE |
			NDIS_ATTRIBUTE_USES_SAFE_BUFFER_APIS,
#else
			NDIS_ATTRIBUTE_DESERIALIZE,
#endif
			NIC_INTERFACE_TYPE);

		Adapter->Timercancelled=TRUE;
		
		// Initialize Link Check Timer
		NdisMInitializeTimer(
								&Adapter->LinkCheckTimer,
								Adapter->AdapterHandle,
								NICLinkCheck,
								Adapter
							);

		//
		// Get the Adapter Resources & Initialize the hardware.
		//

		Status = NICInitializeAdapter(Adapter);
		if(Status != NDIS_STATUS_SUCCESS) {
			Status = NDIS_STATUS_FAILURE;
			break;
		}

	} while(FALSE);

	if(Status == NDIS_STATUS_SUCCESS) {

		Adapter->MPInitializeFail=FALSE;
		MP_CLEAR_FLAG(Adapter, fMP_INIT_IN_PROGRESS);
	}
	else {
		if(Adapter){
			MP_CLEAR_FLAG(Adapter, fMP_INIT_IN_PROGRESS);
			Adapter->MPInitializeFail=TRUE;
			MPHalt(Adapter);
		}
	}

	Adapter->MPInitialized=TRUE;

	SMSC_TRACE1(DBG_INIT,"<-- MPInitialize Status = 0x%08x%\r\n", Status);

	return Status;
}

/*++

Routine Description:

	The MiniportCheckForHang handler is called to report the state of the
	NIC, or to monitor the responsiveness of an underlying device driver.
	This is an optional function. If this handler is not specified, NDIS
	judges the driver unresponsive when the driver holds
	MiniportQueryInformation or MiniportSetInformation requests for a
	time-out interval (deafult 4 sec), and then calls the driver's
	MiniportReset function. A NIC driver's MiniportInitialize function can
	extend NDIS's time-out interval by calling NdisMSetAttributesEx to
	avoid unnecessary resets.

Arguments:

	MiniportAdapterContext	Pointer to our adapter

Return Value:

	TRUE	NDIS calls the driver's MiniportReset function.
	FALSE	Everything is fine

Note:
	CheckForHang handler is called in the context of a timer DPC.
	take advantage of this fact when acquiring/releasing spinlocks

--*/

BOOLEAN
MPCheckForHang(
	IN NDIS_HANDLE MiniportAdapterContext
	)

{
	PMP_ADAPTER	Adapter = (PMP_ADAPTER) MiniportAdapterContext;
	BOOLEAN 	bReset = (MP_TEST_FLAG(Adapter, fMP_NEED_FULL_RESET) && (!MP_TEST_FLAG(Adapter, fMP_DEVICE_NOT_ATTACHED))) ;

	if (bReset)
		SMSC_TRACE1(DBG_RESET," MPCheckForHang, (%s) \r\n", bReset ? "RESET" : "NO RESET");

	return(bReset);
}



/*++

Routine Description:

	The Halt handler should free all the resources acquired
	in MiniportInitialize and stop access to the hardware. NDIS will
	not submit any further request once this handler is invoked.

	1) Free and unmap all I/O resources.
	2) Disable interrupt and deregister interrupt handler.
	3) Deregister shutdown handler regsitered by
		NdisMRegisterAdapterShutdownHandler.
	4) Cancel all queued up timer callbacks.
	5) Finally wait indefinitely for all the outstanding receive
		packets indicated to the protocol to return.


Arguments:

	MiniportAdapterContext	Pointer to the Adapter

Return Value:

	None.

--*/
VOID
MPHalt(
	IN	NDIS_HANDLE MiniportAdapterContext
	)

{



	PMP_ADAPTER 	  Adapter = (PMP_ADAPTER) MiniportAdapterContext;
	int Count = 0;


	SMSC_TRACE0(DBG_SHUT_DOWN,"--> MPHalt\r\n");


	ASSERT(!MP_TEST_FLAG(Adapter, fMP_INIT_IN_PROGRESS));

	MP_SET_FLAG(Adapter, fMP_HALT_IN_PROGRESS);

	// If a media status query was pending lets complete it now !
	if (MP_TEST_FLAG(Adapter, fMP_REQUEST_PENDING));
		NICCompleteOidQueryIfPending(Adapter);

	// If a USB Recovery workitem is running we need to wait till it finishes.
	while (MP_TEST_FLAG(Adapter, fMP_USB_RESET_IN_PROGRESS) || Adapter->IsUsbErrorRecoveryWorkItemQueued)
	{
		NdisMSleep(NDIS_SLEEP_5_MS);	// Wait 5 msec and try again.
		if (++Count == 1000)
		{
			// If we spent 5 secs or more then something failed.
			SMSC_TRACE0(DBG_ERROR,"Timeout waiting USB Recovery completion during MPHalt\r\n");
			// We'll probably crash because we'll pull the rug from under
			// the workitem's feet, but what else can we do ...
			break;
		}
	}

	// First cancel the Link Check Timer
	SafeCancelLinkCheck(Adapter);

	#ifdef USE_INT_PIPE
	if (Adapter->StopBulkInOnRxEmpty) {
		NICStopInterruptPipe(Adapter);
	}
	#endif

	NICStopAndFlushRxPath(Adapter);
	NICStopAndFlushTxPath(Adapter);
	NICFreeQueuedSendPackets(Adapter);

	NICFreeSendResources(Adapter);
	NICFreeRecvResources(Adapter);
	#ifdef USE_INT_PIPE
	NICFreeIntResources(Adapter);
	#endif
	if (Adapter->WolPatternMatchSettings != DISABLED)
	{
		NICFreeWolResources(Adapter);
	}

	
	// Turn Off Link GPIO LED
//	NICSetGpo(Adapter, Adapter->LinkLedOnGpio, LED_OFF);

	
	//
	// Call Shutdown handler to disable interrupt and turn the hardware off
	// by issuing a full reset
	//
#if defined(NDIS50_MINIPORT)

	MPShutdown(MiniportAdapterContext);

#elif defined(NDIS51_MINIPORT)

	// Before accessing the device, check to see
	// if the device is surprise removed, if so don't bother calling
	// the shutdown handler to stop the hardware because it doesn't exist.
	//
	if(!MP_TEST_FLAG(Adapter, fMP_SURPRISE_REMOVED)) {
		MPShutdown(MiniportAdapterContext);
	}

#endif

	//
	// Decrement the ref count which was incremented in MPInitialize
	//

	MP_DEC_REF(Adapter);

	NdisWaitEvent(&Adapter->HaltEvent, 0);

#ifdef NDIS50_MINIPORT
	//
	// Deregister shutdown handler as it's being halted
	//
	NdisMDeregisterAdapterShutdownHandler(Adapter->AdapterHandle);
#endif

	NICFreeAdapter(Adapter);

	MP_CLEAR_FLAG(Adapter, fMP_HALT_IN_PROGRESS);

	SMSC_TRACE0(DBG_SHUT_DOWN,"<-- MPHalt\r\n");

}

/*++

Routine Description:

	MiniportReset is a required to issue a hardware reset to the NIC
	and/or to reset the driver's software state.

	1) The miniport driver can optionally complete any pending
		OID requests. NDIS will submit no further OID requests
		to the miniport driver for the NIC being reset until
		the reset operation has finished. If you return Status_success
		and still have any pending OIDs, NDIS will complete the OID
		on your behalf. So make sure to complete the pending OIDs
		before returning SUCCESS.

	2) A deserialized miniport driver must complete any pending send
		operations. NDIS will not requeue pending send packets for
		a deserialized driver since NDIS does not maintain the send
		queue for such a driver.

	3) If MiniportReset returns NDIS_STATUS_PENDING, the driver must
		complete the original request subsequently with a call to
		NdisMResetComplete.


Arguments:

AddressingReset - If multicast or functional addressing information
				  or the lookahead size, is changed by a reset,
				  MiniportReset must set the variable at AddressingReset
				  to TRUE before it returns control. This causes NDIS to
				  call the MiniportSetInformation function to restore
				  the information.

MiniportAdapterContext - Pointer to our adapter

Return Value:

	NDIS_STATUS

--*/

NDIS_STATUS
MPReset(
	OUT PBOOLEAN AddressingReset,
	IN	NDIS_HANDLE MiniportAdapterContext
	)
{
	PMP_ADAPTER 	  Adapter = (PMP_ADAPTER) MiniportAdapterContext;
	NDIS_STATUS Status = NDIS_STATUS_SUCCESS;
	NIC_STATUS	NicStatus=NIC_STATUS_SUCCESS;


	SMSC_TRACE0(DBG_RESET,"--> MPReset\r\n");
	ASSERT(!MP_TEST_FLAG(Adapter, fMP_RESET_IN_PROGRESS));

	if (!Adapter->MPInitialized) {
        Adapter->HardwareStatus = NdisHardwareStatusNotReady;
		return NDIS_STATUS_SUCCESS;
    }

	if ( Adapter->MPInitializeFail ) {
        Adapter->HardwareStatus = NdisHardwareStatusNotReady;
		return NDIS_STATUS_HARD_ERRORS;
    }

	NdisAcquireSpinLock(&Adapter->RequestLock);

	MP_SET_FLAG(Adapter, fMP_RESET_IN_PROGRESS);

	MP_CLEAR_FLAG(Adapter, fMP_NEED_FULL_RESET);

	MP_CLEAR_FLAG(Adapter, fMP_PERIODIC_LINK_CHECK);
	

	*AddressingReset = FALSE;

	Adapter->SecondsElapsedAfterMPResetExit = 0;	// Prevent early reset completion.
	Adapter->HardwareStatus = NdisHardwareStatusReset;
	
	NicStatus=NICReset(Adapter);
	
	if (NicStatus==NIC_STATUS_SUCCESS) {
		Status = NDIS_STATUS_SUCCESS;
        Adapter->HardwareStatus = NdisHardwareStatusReady;
    }
	else
    {   
		Status = NDIS_STATUS_HARD_ERRORS;
        Adapter->HardwareStatus = NdisHardwareStatusNotReady;
    }
    

	NdisReleaseSpinLock(&Adapter->RequestLock);

	SMSC_TRACE0(DBG_RESET,"<-- MPReset\r\n");
	return Status;

}

/*++

Routine Description:

	The MiniportShutdown handler restores a NIC to its initial state when
	the system is shut down, whether by the user or because an unrecoverable
	system error occurred. This is to ensure that the NIC is in a known
	state and ready to be reinitialized when the machine is rebooted after
	a system shutdown occurs for any reason, including a crash dump.

	Here just disable the interrupt.
	Do not free memory resources or wait for any packet transfers
	to complete.

Arguments:

	MiniportAdapterContext	Pointer to our adapter

Return Value:

	None

--*/
VOID
MPShutdown(
	IN NDIS_HANDLE MiniportAdapterContext
	)

{
	PMP_ADAPTER Adapter = (PMP_ADAPTER) MiniportAdapterContext;

	SMSC_TRACE0(DBG_SHUT_DOWN,"--> MPShutdown\r\n");

	MP_CLEAR_FLAG(Adapter, fMP_POST_INTS);
	MP_CLEAR_FLAG(Adapter, fMP_POST_WRITES);
	MP_CLEAR_FLAG(Adapter, fMP_POST_READS);
	MP_CLEAR_FLAG(Adapter, fMP_PERIODIC_LINK_CHECK);

   SMSC_TRACE0(DBG_SHUT_DOWN,"<-- MPShutdown\r\n");

}



/* ++
 Routine Description:

 
	 The UsbDeviceNotify routine Processes notifications from USBD.  Currently, the only notification
	 supported is a device removal.  Unused parameters are reserved for future use.
	 
Arguments:

Return Value:

Note: do not assume that the USB stack will call this routine immediately after the device is unplugged.
	  It could take some time for it to cleanup and get back to us.
-- */
BOOL WINAPI
UsbDeviceNotify(
   LPVOID lpvNotifyParameter,
   DWORD dwCode,
   LPDWORD * dwInfo1,
   LPDWORD * dwInfo2,
   LPDWORD * dwInfo3,
   LPDWORD * dwInfo4
   )
{
   PMP_ADAPTER pUsbDevice = (PMP_ADAPTER)lpvNotifyParameter;
   int Timeout=0;

   UNREFERENCED_PARAMETER(dwInfo1);
   UNREFERENCED_PARAMETER(dwInfo2);
   UNREFERENCED_PARAMETER(dwInfo3);
   UNREFERENCED_PARAMETER(dwInfo4);

   SMSC_TRACE0(DBG_INIT,"-->UsbDeviceNotify\r\n");

   if ( !VALID_CONTEXT( pUsbDevice ) ) {
	  SMSC_TRACE0(DBG_ERROR,"Invalid Context!\r\n");
	  return FALSE;
   }

   switch(dwCode) {

	  case USB_CLOSE_DEVICE:
		MP_SET_FLAG(pUsbDevice, fMP_SURPRISE_REMOVED);
		MP_SET_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED);
		pUsbDevice->Dev_Flags.AcceptIo = FALSE;
		pUsbDevice->Dev_Flags.DeviceRemoved = TRUE;
//		GlobalData.DeviceAttached=FALSE;


		// ensure the NdisStartUpThread terminated
		//

		if (MP_TEST_FLAG(pUsbDevice, fMP_REQUEST_PENDING) && (!pUsbDevice->MPInitializeFail))
			NICCompleteOidQueryIfPending(pUsbDevice);
		
		if (pUsbDevice->hNdisStartUpThread) {
			WaitForSingleObject(pUsbDevice->hNdisStartUpThread, INFINITE);
		}

		if (MP_TEST_FLAG(pUsbDevice, fMP_REQUEST_PENDING) && (!pUsbDevice->MPInitializeFail))
			NICCompleteOidQueryIfPending(pUsbDevice);

		MP_CLEAR_FLAG(pUsbDevice, fMP_PERIODIC_LINK_CHECK);
		MP_CLEAR_FLAG(pUsbDevice, fMP_POST_INTS);
		MP_CLEAR_FLAG(pUsbDevice, fMP_POST_WRITES);
		MP_CLEAR_FLAG(pUsbDevice, fMP_POST_READS);

		
		// Check if the workitem has finished and if not wait for it.
		while (MP_TEST_FLAG(pUsbDevice, fMP_LINK_CHECK_IN_PROGRESS))
		{
			NdisMSleep(NDIS_SLEEP_1_MS);
			if (++Timeout >= NIC_2_SEC_TIMEOUT)
			{
				SMSC_TRACE0(DBG_ERROR,"ERROR: In UsbDeviceNotify,Timer Callback workitem did not complete within 2 seconds\r\n");

			}
		}

	
		if (MP_TEST_FLAG(pUsbDevice, fMP_USB_RESET_IN_PROGRESS))
			SMSC_TRACE0(DBG_ERROR,"ERROR: In UsbDeviceNotify,USB RESET in progress\r\n");
	
		Timeout=0;
		while (MP_TEST_FLAG(pUsbDevice, fMP_USB_RESET_IN_PROGRESS))
		{
			NdisMSleep(NDIS_SLEEP_1_MS);
			if (++Timeout >= NIC_1_SEC_TIMEOUT)
			{
				SMSC_TRACE0(DBG_ERROR,"ERROR: In UsbDeviceNotify,USB RESET did not complete within 1 seconds\r\n");
				break;
	
			}
		}

		if (MP_TEST_FLAG(pUsbDevice, fMP_RESET_IN_PROGRESS))
			SMSC_TRACE0(DBG_ERROR,"ERROR: In UsbDeviceNotify,RESET in progress\r\n");

		Timeout=0;
		while (MP_TEST_FLAG(pUsbDevice, fMP_RESET_IN_PROGRESS))
		{
			NdisMSleep(NDIS_SLEEP_1_MS);
			if (++Timeout >= NIC_1_SEC_TIMEOUT)
			{
				SMSC_TRACE0(DBG_ERROR,"ERROR: In UsbDeviceNotify,RESET did not complete within 1 seconds\r\n");
				break;

			}
		}

		if (!pUsbDevice->MPInitializeFail) {
			if(MP_TEST_FLAG(pUsbDevice, fMP_REQUEST_PENDING))
				NICCompleteOidQueryIfPending(pUsbDevice);
		
			NICStopBulkIn(pUsbDevice);
			NICStopBulkOut(pUsbDevice);
			NICFreeQueuedSendPackets(pUsbDevice);
			#ifdef USE_INT_PIPE
			if(pUsbDevice->StopBulkInOnRxEmpty) {
				NICStopInterruptPipe(pUsbDevice);
			}
			#endif
		}


		StopUsbThread(pUsbDevice, FALSE);
		RemoveDeviceContext( pUsbDevice );

		return TRUE;

		default:
			SMSC_TRACE1(DBG_ERROR,"Unhandled code:%d\r\n", dwCode);
			break;
	}

   SMSC_TRACE0(DBG_INIT,"<--UsbDeviceNotify\r\n");

   return FALSE;
}


/*++

Routine Description:

	The RemoveDeviceContext routine free all the resources acquired
	in UsbDeviceAttach() and stop access to the hardware. 
 
Arguments:

	pUsbDevice	Pointer to the Adapter

Return Value:

	None.

--*/
VOID
RemoveDeviceContext(
   PMP_ADAPTER pUsbDevice
   )
{

	int i=0;
	
	SMSC_TRACE1(DBG_SHUT_DOWN,"-->RemoveDeviceContext(%p)\r\n", pUsbDevice);
	
	if ( VALID_CONTEXT( pUsbDevice ) ) {

		EnterCriticalSection (&GlobalData.Access_Instance);
		if (GlobalData.Instances[pUsbDevice->InstanceIndex]==1) {
	   		GlobalData.Instances[pUsbDevice->InstanceIndex]=0;
	   		GlobalData.Adapter[pUsbDevice->InstanceIndex]=NULL;
	   		GlobalData.InstancesCount--;
		}
    	LeaveCriticalSection (&GlobalData.Access_Instance);

		CloseAllPipes(pUsbDevice);
		pUsbDevice->Dev_Flags.PipeClosed=1;
		LocalFree(pUsbDevice);
		pUsbDevice=NULL;

   } else {
		SMSC_TRACE0(DBG_ERROR,"Invalid Parameter\r\n");
   }

	EnterCriticalSection (&GlobalData.Access_Instance);
   	if (GlobalData.InstancesCount==0) {
		GlobalData.DeviceAttached=FALSE;
		GlobalData.DriverEntryInit=FALSE;
		for (i=0;i<Num_of_Instances_supported;i++) {
			GlobalData.Adapter[i]=NULL;
			GlobalData.Instances[i]=0;
		}

   	}
	LeaveCriticalSection (&GlobalData.Access_Instance);
	
   SMSC_TRACE0(DBG_SHUT_DOWN,"<--RemoveDeviceContext\r\n");

   return;
}



/* ++

Routine Description:

	Inform NDIS there is a new NIC, which invokes our microport's DriverEntry,
	which then loads up the Ndis miniport driver.

	We have to do this in a seperate thread context from UsbDeviceAttach so we
	don't cause deadlock on UHCI.

	
Arguments:

	Context 	Pointer to the Adapter

Return Value:

	ERROR_SUCCESS.


-- */
DWORD
NdisStartUpThread(
	LPVOID Context
	)
{
	PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;
	NDIS_STATUS NdisStatus = STATUS_SUCCESS;

	SMSC_TRACE1(DBG_INIT,"-->NdisStartUpThread, Pri:%d \r\n",
		CeGetThreadPriority(GetCurrentThread()));

	if ( !VALID_CONTEXT( pDevice ) ) {
		SMSC_TRACE0(DBG_ERROR,"Invalid Context!\r\n");
		ExitThread(ERROR_INVALID_PARAMETER);
		return ERROR_INVALID_PARAMETER;
	}

	
	SMSC_TRACE0(DBG_INIT,"--> NdisRegisterAdapter()...\r\n");

	NdisRegisterAdapter( &NdisStatus,
						 CLASS_NAME_SZ,
						 pDevice->InstanceName);

	SMSC_TRACE0(DBG_INIT,"<-- NdisRegisterAdapter()...\r\n");

	if (NdisStatus == NDIS_STATUS_SUCCESS) {
		pDevice->NdisInitialized = TRUE;
	} else {
		SMSC_TRACE1(DBG_INIT,"NdisRegisterAdapter ERROR: 0x%x\n", NdisStatus );
		StopUsbThread(pDevice, FALSE);
	}

	SMSC_TRACE0(DBG_INIT,"<-- NdisStartUpThread\r\n");

	ExitThread(ERROR_SUCCESS);

	return ERROR_SUCCESS;
}


/* ++

Routine Description:

	Inform NDIS to remove this Adapter.    

Arguments:

	pDevice 	Pointer to the Adapter
	bWaitForStartup    Wait for the StartUp Thread to finish before Deregister this Adapter

Return Value:

	None

-- */
VOID
StopUsbThread(
	PMP_ADAPTER pDevice,
	BOOL bWaitForStartup
	)
{
	NDIS_STATUS NdisStatus;
	int TimeOut=0;

	SMSC_TRACE0(DBG_SHUT_DOWN,"-->StopUsbThread\r\n")

	if (!VALID_CONTEXT(pDevice)) {
		SMSC_TRACE0(DBG_SHUT_DOWN,"Not a Valid Context\r\n");
		return;
	}

	pDevice->Dev_Flags.AcceptIo = FALSE;
	pDevice->Dev_Flags.DeviceRemoved = TRUE;
	
	//
	// ensure the NdisStartUpThread terminated
	//

        
	if (pDevice->hNdisStartUpThread && bWaitForStartup) {
        
		WaitForSingleObject(pDevice->hNdisStartUpThread, INFINITE);
	}

    if (pDevice->hNdisStartUpThread) {
        CloseHandle(pDevice->hNdisStartUpThread);
    }

	#ifdef USE_THREAD
	//
	// wait for the RecvThread to terminate
	//
	if (pDevice->hRecvThread && pDevice->RecvThreadEvent) {

		pDevice->RecvThreadExitFlag = TRUE;
		SetEvent(pDevice->RecvThreadEvent);

		WaitForSingleObject(pDevice->hRecvThread, INFINITE);
	}
    if (pDevice->hRecvThread){
        CloseHandle(pDevice->hRecvThread);
        }

	 //
	// wait for the SendThread to terminate
	//
	if (pDevice->hSendThread && pDevice->SendThreadEvent) {

		pDevice->SendThreadExitFlag = TRUE;
		SetEvent(pDevice->SendThreadEvent);

		WaitForSingleObject(pDevice->hSendThread, INFINITE);
	}

    
    if (pDevice->hSendThread){
            CloseHandle(pDevice->hSendThread);
    }

	#endif

	
	#ifdef USE_WORK_ITEM_NO_OUT
	pDevice->SendWorkItemExitFlag = TRUE;
	NdisSetEvent(&pDevice->SendWorkItemReady);
	pDevice->RecvWorkItemExitFlag = TRUE;
	NdisSetEvent(&pDevice->RecvWorkItemReady);
	#endif


	#ifdef USE_INT_PIPE
	#ifdef USE_THREAD
	//
	// wait for the IntThread to terminate
	//
	if (pDevice->hIntThread && pDevice->IntThreadEvent) {

		pDevice->IntThreadExitFlag = TRUE;
		SetEvent(pDevice->IntThreadEvent);

		WaitForSingleObject(pDevice->hIntThread, INFINITE);
	}

     if (pDevice->hIntThread){
            CloseHandle(pDevice->hIntThread);
     }
	#endif

	#ifdef USE_WORK_ITEM_NO_OUT

	pDevice->IntWorkItemExitFlag = TRUE;
	NdisSetEvent(&pDevice->IntsWorkItemReady);

	#endif
	#endif

	while (MP_TEST_FLAG(pDevice, fMP_RESET_IN_PROGRESS))
	{
		NdisMSleep(NDIS_SLEEP_1_MS);
		if (++TimeOut>= NIC_2_SEC_TIMEOUT)
		{
			SMSC_TRACE0(DBG_ERROR,"ERROR: In StopUsbThread,RESET did not complete within 10 seconds\r\n");
			break;

		}
	}

	SMSC_TRACE0(DBG_SHUT_DOWN,"--> NdisDeregisterAdapter()...\r\n");

	NdisDeregisterAdapter(&NdisStatus,
						  pDevice->InstanceName );


	if (NdisStatus != NDIS_STATUS_SUCCESS) {
		SMSC_TRACE1(DBG_ERROR, "NdisDeRegisterAdapter Failed : 0x%x\n", NdisStatus);
	}
	SMSC_TRACE0(DBG_SHUT_DOWN,"<-- NdisDeregisterAdapter()...\r\n");

	SMSC_TRACE0(DBG_SHUT_DOWN,"<--StopUsbThread\r\n");

	return;
}

/* ++

Routine Description:

	
	Retrieves the descriptor and validates it.
	

Arguments:

	
Return Value:

	USB_INTERFACE
   
-- */

LPCUSB_INTERFACE
ParseUsbDescriptors(
   USB_HANDLE		hUsbDevice,
   LPCUSB_FUNCS 	UsbFuncs,
   LPCUSB_INTERFACE CurInterface,
   LPUSHORT 		ConfigIndex,
   PUCHAR			PdmAttributes
   )

{
	LPCUSB_DEVICE	   pDevice;
	LPCUSB_INTERFACE   pUsbInterface;
	LPCUSB_INTERFACE   pDesiredInterface = NULL;

	DWORD dwNumInterfaces;
	DWORD dwIndex;

	SMSC_TRACE0(DBG_INIT,"-->ParseUsbDescriptors\r\n");

	if ( !hUsbDevice || !UsbFuncs  || !ConfigIndex) {
		SMSC_TRACE4(DBG_ERROR,"Invalid parameter 0x%x,0x%x,0x%x,%d\r\n",hUsbDevice,UsbFuncs,CurInterface,ConfigIndex);
		return NULL;
	}


	//
	// get the descriptors
	//
	pDevice = UsbFuncs->lpGetDeviceInfo( hUsbDevice );
	if ( !pDevice ) {
		SMSC_TRACE1(DBG_ERROR,"GetDeviceInfo error:%d\r\n", GetLastError() );
		return NULL;
	}


	// get config index
	for ( *ConfigIndex = 0; *ConfigIndex < (USHORT)pDevice->Descriptor.bNumConfigurations; *ConfigIndex++) {
		if (pDevice->lpActiveConfig == (pDevice->lpConfigs + *ConfigIndex)) {
			SMSC_TRACE1(DBG_INIT,"ConfigIndex:%d\r\n", *ConfigIndex);
			break;
	  }
	}

	pUsbInterface	= pDevice->lpActiveConfig->lpInterfaces;
	dwNumInterfaces = pDevice->lpActiveConfig->dwNumInterfaces;

	// walk the interfaces searching for best fit
	for ( dwIndex = 0; dwIndex < dwNumInterfaces; pUsbInterface++, dwIndex++)
	{
		

			if (  pUsbInterface->Descriptor.bInterfaceClass == SMSC7500_INTERFACE_CLASS &&
				 (pUsbInterface->Descriptor.bInterfaceSubClass >= SMSC7500_INTERFACE_SUBCLASS) &&
				 (pUsbInterface->Descriptor.bInterfaceProtocol == SMSC7500_INTERFACE_PROTOCOL ))
			{
				
					pDesiredInterface = pUsbInterface;
					SMSC_TRACE1(DBG_INIT,"*** Found interface @ index: %d ***\r\n", dwIndex);

		}
	}

	*PdmAttributes=pDevice->lpActiveConfig->Descriptor.bmAttributes;
	SMSC_TRACE1(DBG_INIT,"*PdmAttributes: 0x%x \r\n", *PdmAttributes);

	SMSC_TRACE1(DBG_INIT,"<--ParseUsbDescriptors:0x%x\r\n", pDesiredInterface);

	return pDesiredInterface;
}


/* ++

Routine Description:

	
	Find a valid interface and open BUlkIn/BulkOut/Interrupt Pipes
	

Arguments:

		pUsbDevice	  Point to the Adapter
		
Return Value:

	True	 if setinterface success
	FALSE  If there is an error

   
-- */
BOOL
SetUsbInterface(
   PMP_ADAPTER	 pUsbDevice
   )
{
   
	BOOL bRc = FALSE;
	DWORD dwIndex;

	SMSC_TRACE0(DBG_INIT,"-->SetUsbInterface\r\n");

	if ( !VALID_CONTEXT( pUsbDevice ) || !pUsbDevice->pUsbInterface ) {
		SMSC_TRACE0(DBG_ERROR,"In SetUsbInterface, Invalid parameter\r\n");
		return FALSE;
	}


	//
	// now parse the endpoints
	//
	for ( dwIndex = 0; dwIndex < pUsbDevice->pUsbInterface->Descriptor.bNumEndpoints; dwIndex++)
	{
		LPCUSB_ENDPOINT pEndpoint;
		pEndpoint = pUsbDevice->pUsbInterface->lpEndpoints + dwIndex;

	  
		//
		// Usb ethernet adapter supports 1 mandatory Bulk OUT, 1 mandatory Bulk IN, and 1 optional INTERRUPT
		//
		if ( USB_ENDPOINT_DIRECTION_OUT( pEndpoint->Descriptor.bEndpointAddress ) ) {
			
			if ( NULL == pUsbDevice->BulkOut.hPipe &&
				(pEndpoint->Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK) == USB_ENDPOINT_TYPE_BULK)
			{
			
				//
				// create the Bulk OUT pipe
				//
				pUsbDevice->BulkOut.hPipe = pUsbDevice->UsbFuncs->lpOpenPipe( pUsbDevice->hUsbDevice,
																			  &pEndpoint->Descriptor );
				if ( !pUsbDevice->BulkOut.hPipe ) {
					SMSC_TRACE1(DBG_ERROR,"OpenPipe error:%d\r\n", GetLastError());
					bRc = FALSE;
					break;
				}

				//
				// setup any endpoint specific timers, buffers, context, etc.
				//
				pUsbDevice->BulkOut.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
				if ( !pUsbDevice->BulkOut.hEvent ) {
					SMSC_TRACE1(DBG_ERROR,"CreateEvent error:%d\r\n", GetLastError() );
					bRc = FALSE;
					break;
				}

				pUsbDevice->BulkOut.bIndex		   = pEndpoint->Descriptor.bEndpointAddress;
				pUsbDevice->BulkOut.wMaxPacketSize = pEndpoint->Descriptor.wMaxPacketSize;
			}

		} else if (USB_ENDPOINT_DIRECTION_IN( pEndpoint->Descriptor.bEndpointAddress ) ) {
		
			if ( NULL == pUsbDevice->BulkIn.hPipe &&
				(pEndpoint->Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK) == USB_ENDPOINT_TYPE_BULK)
			{
				//
				// create the Bulk IN pipe
				//
				pUsbDevice->BulkIn.hPipe = pUsbDevice->UsbFuncs->lpOpenPipe( pUsbDevice->hUsbDevice,
																			&pEndpoint->Descriptor );
				if ( !pUsbDevice->BulkIn.hPipe ) {
					SMSC_TRACE1(DBG_ERROR,"OpenPipe error: %d\r\n", GetLastError() );
					bRc = FALSE;
					break;
				}

				//
				// setup any endpoint specific timers, buffers, context, etc.
				//
				pUsbDevice->BulkIn.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
				if ( !pUsbDevice->BulkIn.hEvent ) {
					SMSC_TRACE1(DBG_ERROR,"CreateEvent error:%d\r\n", GetLastError());
					bRc = FALSE;
					break;
				}

				pUsbDevice->BulkIn.bIndex		  = pEndpoint->Descriptor.bEndpointAddress;
				pUsbDevice->BulkIn.wMaxPacketSize = pEndpoint->Descriptor.wMaxPacketSize;

			} else if ( NULL == pUsbDevice->Interrupt.hPipe &&
				(pEndpoint->Descriptor.bmAttributes & USB_ENDPOINT_TYPE_MASK) == USB_ENDPOINT_TYPE_INTERRUPT)
			{
				//
				// create the Interrupt pipe
				//
				pUsbDevice->Interrupt.hPipe = pUsbDevice->UsbFuncs->lpOpenPipe( pUsbDevice->hUsbDevice,
																				&pEndpoint->Descriptor );
			   if ( !pUsbDevice->Interrupt.hPipe ) {
					SMSC_TRACE1(DBG_ERROR,"OpenPipe error: %d\r\n", GetLastError());
					bRc = FALSE;
					break;
			   }

			   //
			   // setup any endpoint specific timers, buffers, context, etc.
			   //
			   pUsbDevice->Interrupt.hEvent = CreateEvent( NULL, TRUE, FALSE, NULL);
			   if ( !pUsbDevice->Interrupt.hEvent ) {
					SMSC_TRACE1(DBG_ERROR,"CreateEvent error:%d\r\n", GetLastError());
					bRc = FALSE;
					break;
			   }

			   pUsbDevice->Interrupt.bIndex 		= pEndpoint->Descriptor.bEndpointAddress;
			   pUsbDevice->Interrupt.wMaxPacketSize = pEndpoint->Descriptor.wMaxPacketSize;
			}

		} else {
		 SMSC_TRACE1(DBG_INIT,"Unsupported Endpoint:0x%x\r\n", pEndpoint->Descriptor.bEndpointAddress);
		}
	}

	//
	// did we find our endpoints?
	//
	bRc = (pUsbDevice->BulkOut.hPipe && pUsbDevice->BulkIn.hPipe && pUsbDevice->Interrupt.hPipe ) ? TRUE : FALSE;

	

	SMSC_TRACE1(DBG_INIT,"<--SetUsbInterface, return %d\r\n", bRc);

	return (bRc);
}


/* ++

Routine Description:

	
	Close the opened pipe
	
Arguments:

		pUsbDevice	  Point to the Adapter
		Pipes			  The opened pipe
		
Return Value:

	None


	
-- */
VOID
ClosePipe(
	PMP_ADAPTER pUsbDevice,
	PIPE Pipes
		)
{

	SMSC_TRACE0(DBG_SHUT_DOWN,"-->ClosePipe\r\n");
	
	if ( !pUsbDevice || !pUsbDevice->UsbFuncs ) {
		SMSC_TRACE0(DBG_ERROR,"Invalid Parameter!\r\n");
		return;
	}

	if (Pipes.hPipe) {
		if (!pUsbDevice->UsbFuncs->lpClosePipe(Pipes.hPipe))
			SMSC_TRACE1(DBG_ERROR,"close pipe failed (%d)\r\n", GetLastError());
	}

	if (Pipes.hEvent) {
		if (!CloseHandle(Pipes.hEvent))
			SMSC_TRACE0(DBG_ERROR,"close pipe event fail!\r\n");
	}
	
	SMSC_TRACE0(DBG_SHUT_DOWN,"<--ClosePipe\r\n");
	return;
}


/* ++

Routine Description:

	
	Close all opened pipes
	
Arguments:

		pUsbDevice	  Point to the Adapter
		
Return Value:

	None


	
-- */

VOID
CloseAllPipes(
	PMP_ADAPTER pUsbDevice)
{
	SMSC_TRACE0(DBG_SHUT_DOWN,"-->CloseAllPipes\r\n");

	if ( VALID_CONTEXT( pUsbDevice ))
	{
		if ( pUsbDevice->Dev_Flags.AcceptIo )
		{
			SMSC_TRACE0(DBG_ERROR,"CloseAllPipes() AcceptIo Set to FALSE.\r\n");
			pUsbDevice->Dev_Flags.AcceptIo = FALSE;
		}

		ClosePipe( pUsbDevice, pUsbDevice->BulkIn);
		ClosePipe( pUsbDevice, pUsbDevice->BulkOut );
		ClosePipe( pUsbDevice,pUsbDevice->Interrupt);
	}

	SMSC_TRACE0(DBG_SHUT_DOWN,"<--CloseAllPipes\r\n");

}	//	CloseAllPipes()


/* ++

Routine Description:

	
	Reset Pipe and Clear feature EndPoint Stall.
	
Arguments:

		pUsbDevice	  Point to the Adapter
		Usbpipe 		Point to the  pipe
		
Return Value:

	TRUE   If Success
	False	 If there is an error
	
-- */
BOOLEAN
NICResetPipe(
	PMP_ADAPTER pUsbDevice,
	PIPE Usbpipe)
{

	
	DWORD dwErr;

	if (MP_TEST_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED)) {
		SMSC_TRACE0(DBG_ERROR,"Device not attached \r\n");
		return FALSE;
		}

	if (!pUsbDevice->UsbFuncs->lpResetPipe(Usbpipe.hPipe)) {
		SMSC_TRACE0(DBG_ERROR,"Reset Pipe fail. \r\n");
		return FALSE;
		}
		
	dwErr = ClearOrSetFeature(
				pUsbDevice->UsbFuncs,
				pUsbDevice->hUsbDevice,
				NULL,
					NULL,
					USB_SEND_TO_ENDPOINT,
					USB_FEATURE_ENDPOINT_STALL,
				Usbpipe.bIndex,
				4000,
				FALSE
				);
	
	dwErr |= USB_ResetEvent(Usbpipe.hEvent);
	
	if (dwErr != ERROR_SUCCESS) {
				SMSC_TRACE1(DBG_ERROR,"Clear feature EndPoint Stall Fail, dwErr= %d \r\n",dwErr);
				return FALSE;
		}

	return TRUE;
}


/*++

Routine Description:

	This routine synchronously writes a value into a device's register.

Arguments:

	pUsbDevice - pointer to our Adapter
	index - Register to write
	pbBuffer - point to the Value to write

Return Value:
	NIC_STATUS_XXX

--*/

NIC_STATUS NICWriteRegister(
	PMP_ADAPTER  pUsbDevice, 
	USHORT index, 
	PDWORD pbBuffer)
{

	USB_DEVICE_REQUEST udr;

	DWORD		  pcbTransferred=0;
	USB_ERROR dwUsbErr;
	NIC_STATUS dwErr=NIC_STATUS_FAILURE,count=0;

	if ( !ACCEPT_IO(pUsbDevice) )
	{
//		SMSC_TRACE0(DBG_ERROR,"NICWriteRegister(),Device is not ready for I/O request!!!\r\n");	
		return NIC_STATUS_FAILURE;
	}

	udr.bmRequestType=USB_REQUEST_HOST_TO_DEVICE | USB_REQUEST_VENDOR | USB_REQUEST_FOR_DEVICE;
	udr.bRequest = USB_VENDOR_REQUEST_WRITE_REGISTER;
	udr.wValue	 = 0;
	udr.wIndex=index;
	udr.wLength  = 04;

  _retry:
	if (MP_TEST_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED)) {
		SMSC_TRACE0(DBG_ERROR,"Write Register Failed, device not attached!!!\r\n");
		dwErr=NIC_STATUS_FAILURE;
		return dwErr;
	}

	dwErr = IssueVendorTransfer( pUsbDevice->UsbFuncs,
								 pUsbDevice->hUsbDevice,
								 NULL,
								 NULL,
								 (USB_OUT_TRANSFER|USB_SHORT_TRANSFER_OK),
								 &udr,
								 pbBuffer,
								 0,
								 &pcbTransferred ,
								 4000,
								 &dwUsbErr );

	if (( NIC_STATUS_SUCCESS != dwErr) || (USB_NO_ERROR != dwUsbErr)) {

		SMSC_TRACE5(DBG_ERROR,"Write Register Error(dwErr %d, dwUsbErr 0x%x, wIndex %d, pcbTransferred %d, *pbBuffer 0x%x)\r\n",
			dwErr, dwUsbErr, udr.wIndex,pcbTransferred, *pbBuffer);

		if (ERROR_SUCCESS == ResetDefaultEndpoint(pUsbDevice->UsbFuncs, pUsbDevice->hUsbDevice) ) {
		   if (count++<3) {
				 SMSC_TRACE1(DBG_ERROR,"Retry IssueVendorTransfer %d times\r\n", count);
				Sleep(ONE_FRAME_PERIOD);
				goto _retry;
			}
		}

		NdisMSleep(NDIS_SLEEP_10_MS);

	   if (!MP_TEST_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED)) {
			SMSC_TRACE0(DBG_ERROR,"Write Register failed, need full reset!!!\r\n");
			MP_SET_FLAG(pUsbDevice, fMP_NEED_FULL_RESET);
		}

		dwErr=NIC_STATUS_FAILURE;
	}
	else
	{
		dwErr=NIC_STATUS_SUCCESS;
	}

	return dwErr;

}



/*++

Routine Description:

	This routine synchronously reads a value from a device's register.

Arguments:

	pUsbDevice - pointer to our Adapter
	index - Register to read
	pbBuffer - Pointer to a dword variable in which we return the value read

Return Value:
	NIC_STATUS_XXX

--*/
NIC_STATUS NICReadRegister(
	PMP_ADAPTER  pUsbDevice, 
	USHORT index, 
	PDWORD pbBuffer)
{

	USB_DEVICE_REQUEST udr;

	DWORD			pcbTransferred=0;
	USB_ERROR dwUsbErr;
	NIC_STATUS dwErr=NIC_STATUS_FAILURE,count=0;

	if (!ACCEPT_IO(pUsbDevice)) {
//		SMSC_TRACE0(DBG_ERROR,"NICReadRegister(),Device is not ready for I/O request!!!\r\n");	
		return NIC_STATUS_FAILURE;
	}

	udr.bmRequestType=USB_REQUEST_DEVICE_TO_HOST | USB_REQUEST_VENDOR | USB_REQUEST_FOR_DEVICE;
	udr.bRequest = USB_VENDOR_REQUEST_READ_REGISTER;
	udr.wValue	 = 0;
	udr.wIndex=index;
	udr.wLength  = 04;


	_retry:

	if (MP_TEST_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED)) {
		SMSC_TRACE0(DBG_ERROR,"Write Register Failed, device not attached!!!\r\n");
		dwErr=NIC_STATUS_FAILURE;
		return dwErr;
	}

	 dwErr = IssueVendorTransfer( pUsbDevice->UsbFuncs,
								 pUsbDevice->hUsbDevice,
								 NULL,
								 NULL,
								 (USB_IN_TRANSFER|USB_SHORT_TRANSFER_OK),
								 &udr,
								  pbBuffer,
								 0,
								 &pcbTransferred,
								 4000,
								 &dwUsbErr );




	if (( NIC_STATUS_SUCCESS != dwErr) || (USB_NO_ERROR != dwUsbErr)) {

		SMSC_TRACE5(DBG_ERROR,"Read Register Error(dwErr %d, dwUsbErr 0x%x, wValue %d, pcbTransferred %d, *pbBuffer 0x%x)\r\n",
			dwErr, dwUsbErr,udr.wIndex, pcbTransferred, *pbBuffer);

		if (ERROR_SUCCESS == ResetDefaultEndpoint(pUsbDevice->UsbFuncs, pUsbDevice->hUsbDevice)) {
		   if (count++<3) {
				 SMSC_TRACE1(DBG_ERROR,"Retry IssueVendorTransfer %d times\r\n", count);
				Sleep(ONE_FRAME_PERIOD);
				goto _retry;
			}
		}


	   NdisMSleep(NDIS_SLEEP_10_MS);

	   if (!MP_TEST_FLAG(pUsbDevice,fMP_DEVICE_NOT_ATTACHED)) {
			SMSC_TRACE0(DBG_ERROR,"Read Register failed, need full reset!!!\r\n");
			MP_SET_FLAG(pUsbDevice, fMP_NEED_FULL_RESET);
		}

		dwErr=NIC_STATUS_FAILURE;
	}
	else
	{

		dwErr=NIC_STATUS_SUCCESS;

	}

	return dwErr;

}



/*++

Routine Description:

	This routine synchronously reads a Phy register.

Arguments:

	pUsbDevice - pointer to our Adapter
	Register - Register to read
	pValue32 - Pointer to a dword variable in which we return the value read

Return Value:

	NIC_STATUS_XXX
--*/
NIC_STATUS
 NICReadPhy(
	PMP_ADAPTER  pUsbDevice,
	DWORD Register,
	DWORD *pValue32
	)

{
	DWORD dwAddr, Value32;
	UINT Count;
	NIC_STATUS Status=NIC_STATUS_FAILURE;

	if (!ACCEPT_IO(pUsbDevice)) {
		SMSC_TRACE0(DBG_ERROR,"NICReadPhy(),Device is not ready for I/O request!!!\r\n");	
		return NIC_STATUS_FAILURE;
	}

	// confirm MII not busy
	Status=NICReadRegister(pUsbDevice, ETH_MII_ACC, &Value32);
	if (((Value32 & ETH_MII_ACC_MII_BUSY_) != 0UL) || (Status != NIC_STATUS_SUCCESS))
	{
		SMSC_TRACE1(DBG_ERROR,"MII is busy in NICReadPhy,Register %d\r\n",Register);
		Status=NIC_STATUS_FAILURE;
		goto Exit_NICReadPhy;
	}

	// set the address, index & direction (read from PHY)
//	dwAddr = ((pUsbDevice->PHYAddress & 0x1FUL)<<11) | ((Register & 0x1FUL)<<6);
	dwAddr = ((pUsbDevice->PHYAddress & 0x1FUL)<<11) | ((Register & 0x1FUL)<<6) | ETH_MII_ACC_MII_BUSY_;
	Status=NICWriteRegister(pUsbDevice, ETH_MII_ACC, &dwAddr);

	if (Status != NIC_STATUS_SUCCESS)
	{
		SMSC_TRACE1(DBG_ERROR,"MII Register Write Fail for 0x%x Register in NICReadPhy\r\n", Register);
		Status=NIC_STATUS_FAILURE;
		goto Exit_NICReadPhy;
	}

	// Loop until the read is completed w/timeout
	for(Count=0;Count<100;Count++)
	{
		Status=NICReadRegister(pUsbDevice, ETH_MII_ACC, &Value32);
		if(!(Value32 & ETH_MII_ACC_MII_BUSY_)|| (Status != NIC_STATUS_SUCCESS))
			break;
	}

	if ((Count < 100) && (Status == NIC_STATUS_SUCCESS))
	{
		Status=NICReadRegister(pUsbDevice, ETH_MII_DATA, pValue32);	
	}
	else
	{
		SMSC_TRACE1(DBG_ERROR,"Timed out reading MII register %X\r\n", Register & 0x1f);
		Status=NIC_STATUS_FAILURE;
		
	}
Exit_NICReadPhy:

	return Status;
} /* NICReadPhy */


/*++

Routine Description:

	This routine synchronously writes a Phy register.

Arguments:

	pUsbDevice - pointer to our Adapter
	Register - Register to write
	Value32 - value to write 

Return Value:

	NIC_STATUS
--*/
NIC_STATUS
NICWritePhy(
	IN PMP_ADAPTER	pUsbDevice,
	IN DWORD Register,
	DWORD Value32
	)
{
	UINT Count;
	DWORD dwAddr, dwTemp;
	NIC_STATUS Status=NIC_STATUS_FAILURE;

	
	if (!ACCEPT_IO(pUsbDevice)) {
			SMSC_TRACE0(DBG_ERROR,"NICWritePhy(),Device is not ready for I/O request!!!\r\n");	
			return NIC_STATUS_FAILURE;
	}
	// confirm MII not busy
	Status=NICReadRegister(pUsbDevice, ETH_MII_ACC, &dwTemp);
	SMSC_TRACE1(DBG_PHY,"before write, ETH_MII_ACC = 0x%x \r\n",dwTemp);

	if (((dwTemp & ETH_MII_ACC_MII_BUSY_) != 0UL) || (Status != NIC_STATUS_SUCCESS))
	{
		SMSC_TRACE1(DBG_ERROR,"MII is busy in NICWritePhy, Register %d\r\n",Register);
		Status=NIC_STATUS_FAILURE;
		goto Exit_NICWritePhy;
	}

	Status=NICWriteRegister(pUsbDevice, ETH_MII_DATA, &Value32);
	if (Status != NIC_STATUS_SUCCESS)
	{
		SMSC_TRACE1(DBG_ERROR,"MII Register Write Fail for %d Register in NICWritePhy\r\n", Register);
		Status=NIC_STATUS_FAILURE;
		goto Exit_NICWritePhy;
	}

	// set the address, index & direction (read from PHY)
	dwAddr = ((pUsbDevice->PHYAddress & 0x1FUL)<<11) | ((Register & 0x1FUL)<<6) | ETH_MII_ACC_MII_WRITE_ | ETH_MII_ACC_MII_BUSY_;
//	dwAddr = ((pUsbDevice->PHYAddress & 0x1FUL)<<11) | ((Register & 0x1FUL)<<6) | ETH_MII_ACC_MII_WRITE_;
	Status=NICWriteRegister(pUsbDevice, ETH_MII_ACC, &dwAddr);
	if (Status != NIC_STATUS_SUCCESS)
	{
		SMSC_TRACE1(DBG_ERROR,"MII Register Write Fail for %d Register in NICWritePhy\r\n", Register);
		Status=NIC_STATUS_FAILURE;
		goto Exit_NICWritePhy;
	}

	/* Loop until the write is completed */
	for(Count=0;Count<100;Count++)
	{
		Status=NICReadRegister(pUsbDevice, ETH_MII_ACC, &dwTemp);
//		SMSC_TRACE1(DBG_PHY,"ETH_MII_ACC = 0x%x \r\n",dwTemp);
		if((!(dwTemp & ETH_MII_ACC_MII_BUSY_)) || (Status != NIC_STATUS_SUCCESS))
			break;
		
	} /* for */

	if ((Count < 100) && (Status == NIC_STATUS_SUCCESS))
    {
        SMSC_TRACE1(DBG_PHY,"Write completed in %d times\r\n",Count);
    }
    else
    {
        SMSC_TRACE2(DBG_PHY,"Timed out writing to MII register %X,ETH_MII_ACC = 0x%x\r\n", 
                            Register & 0x1f,dwTemp);
    }


Exit_NICWritePhy:

	return Status;

} /* NICWritePhy */


/*++

Routine Description:

	This routine synchronously reads the statistics block from the device.

Arguments:

	Adapter - pointer to our Adapter
	pValue - Pointer to a dword array where to store the stats read

Return Value:

--*/
NIC_STATUS
NICReadStats(
	IN PMP_ADAPTER Adapter,
	OUT PUCHAR pStats
	)

{

	USB_DEVICE_REQUEST udr;

	DWORD			pTxTransferred=0,pRxTransferred=0;
	USB_ERROR dwUsbErr;
	int dwErr=NIC_STATUS_FAILURE;

	udr.bmRequestType=USB_REQUEST_DEVICE_TO_HOST | USB_REQUEST_VENDOR | USB_REQUEST_FOR_DEVICE;
	udr.bRequest = USB_VENDOR_REQUEST_GET_STATS;
	udr.wValue	 = 0;
	udr.wIndex=0;  // 0 for RX status
	udr.wLength  = 0x20UL;

	 
	if (!ACCEPT_IO(Adapter)) {
		 SMSC_TRACE0(DBG_ERROR,"NICReadStatus Failed, device is not ready for I/O request!!!\r\n");
		 return dwErr;
	}


	dwErr = IssueVendorTransfer( Adapter->UsbFuncs,
								 Adapter->hUsbDevice,
								 NULL,
								 NULL,
								 (USB_IN_TRANSFER|USB_SHORT_TRANSFER_OK),
								 &udr,
								  pStats,
								 0,
								 &pRxTransferred,
								 4000,
								 &dwUsbErr );


	if ( ERROR_SUCCESS != dwErr || USB_NO_ERROR != dwUsbErr )
				goto Exit_NICReadStats;


	udr.bmRequestType=USB_REQUEST_DEVICE_TO_HOST | USB_REQUEST_VENDOR | USB_REQUEST_FOR_DEVICE;
	udr.bRequest = USB_VENDOR_REQUEST_GET_STATS;
	udr.wValue	 = 0;
	udr.wIndex=1; ///1 for TX status
	udr.wLength  = 0x28UL;


	dwErr = IssueVendorTransfer( Adapter->UsbFuncs,
								Adapter->hUsbDevice,
								NULL,
								NULL,
								(USB_IN_TRANSFER|USB_SHORT_TRANSFER_OK),
								&udr,
								pStats+sizeof(LAN7500_RX_STATS),
								0,
								&pTxTransferred,
								4000,
								&dwUsbErr );
		



Exit_NICReadStats:

	if ( ERROR_SUCCESS == dwErr || USB_NO_ERROR == dwUsbErr )
		return NIC_STATUS_SUCCESS;
	else
		return NIC_STATUS_FAILURE;

}

/*++

Routine Description:

	This routine reads a byte from the EEPROM 

Arguments:

	Adapter 	Pointer to our adapter
	Address 	Byte offset into the EEPROM to read
	pValue		Pointer to a byte location where the read value is returned

Return Value:

	NIC_STATUS_XXX.

--*/
NIC_STATUS
NICReadEepromByte(
	IN PMP_ADAPTER Adapter,
	IN WORD Address,
	OUT PBYTE pValue
	)

{
	DWORD Timeout = 0UL, Value32,dwTemp;
	NIC_STATUS Status = NIC_STATUS_FAILURE;

	SMSC_TRACE0(DBG_EEPROM,"--> NICReadEepromByte\r\n");
	if (Address & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM read byte address = %d > %d = max eeprom address \r\n", Address, ETH_E2P_CMD_EPC_ADDR_);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICReadEepromByte;
	}

	dwTemp=ETH_E2P_CMD_EPC_TIMEOUT_;
	Status =NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);// Clear the timeout if it was set.
	if (Status != NIC_STATUS_SUCCESS)
		goto Exit_NICReadEepromByte;

	// Program the read command
	dwTemp=ETH_E2P_CMD_EPC_BUSY_ | ETH_E2P_CMD_EPC_CMD_READ_ | Address;
	Status =NICWriteRegister(	Adapter,
						ETH_E2P_CMD,
						&dwTemp);	
	if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICReadEepromByte;
	

	while (Timeout++ <= 300)
	{
		Status =NICReadRegister(Adapter, ETH_E2P_CMD, &Value32);
		
		if (Status != NIC_STATUS_SUCCESS)
				break;
		
		if (Value32 & ETH_E2P_CMD_EPC_TIMEOUT_)		// Timed-out
		{
			Status = NIC_STATUS_FAILURE;
			break;
		}

		if (Value32 & ETH_E2P_CMD_EPC_BUSY_)			// Not done yet.
		{
			continue;
		}
		else
		{
			break;
		}
	}

	if ((Timeout > 300) || (Status != NIC_STATUS_SUCCESS))	// After 30ms it has failed.
	{
		SMSC_TRACE1(DBG_ERROR,"Timed out reading from EEPROM address 0x%03x\r\n", Address);
		*pValue =  0; // Make the return the less evil in case the caller ignores the status
		Status = NIC_STATUS_FAILURE;
	}
	else
	{
		Status =NICReadRegister(Adapter, ETH_E2P_DATA, &Value32);
		if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICReadEepromByte;
		*pValue = (BYTE) (Value32 & ETH_E2P_DATA_EEPROM_DATA_);
		SMSC_TRACE2(DBG_EEPROM,"Read 0x%02x from EEPROM address 0x%03x\r\n", *pValue, Address);
		Status = NIC_STATUS_SUCCESS;
	}

Exit_NICReadEepromByte:
	SMSC_TRACE0(DBG_EEPROM,"<-- NICReadEepromByte\r\n");
	return Status;
}


/*++

Routine Description:

	This routine writes a byte to the EEPROM

Arguments:

	Adapter 	Pointer to our adapter
	Address		Byte offset into the EEPROM to write
	pValue		Pointer to a byte location where the write value is located

Return Value:

	NIC_STATUS.

--*/
NIC_STATUS
NICWriteEepromByte(
	IN PMP_ADAPTER Adapter,
	IN WORD Address,
	IN PBYTE pValue
	)

{
	DWORD Timeout = 0UL, Value32,dwTemp;
	NIC_STATUS Status = NIC_STATUS_FAILURE;
	SMSC_TRACE0(DBG_EEPROM,"--> NICWriteEepromByte\r\n");

	if (Address & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM write byte address = %d > %d = max eeprom address \r\n", Address, ETH_E2P_CMD_EPC_ADDR_);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICWriteEepromByte;
	}

	dwTemp=ETH_E2P_CMD_EPC_TIMEOUT_;
	Status=NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);	// Clear the timeout if it was set.
	if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICWriteEepromByte;

	Status=NICWriteRegister(Adapter, ETH_E2P_DATA, (PDWORD)pValue);	// Set the data to write
	if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICWriteEepromByte;

	// Program the write command
	dwTemp=ETH_E2P_CMD_EPC_BUSY_ | ETH_E2P_CMD_EPC_CMD_WRITE_ | Address;
	Status=NICWriteRegister(	Adapter,
						ETH_E2P_CMD,
						&dwTemp);
	if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICWriteEepromByte;

	while (Timeout++ <= 300)
	{
		Status=NICReadRegister(Adapter, ETH_E2P_CMD, &Value32);
		if (Status != NIC_STATUS_SUCCESS) {
			break;
			}
		
		if (Value32 & ETH_E2P_CMD_EPC_TIMEOUT_)		// Timed-out
		{
			Status = NIC_STATUS_FAILURE;
			break;
		}

		if (Value32 & ETH_E2P_CMD_EPC_BUSY_)			// Not done yet.
		{
			continue;
		}
		else
		{
			break;
		}
	}

	if ((Timeout > 300)|| (Status != NIC_STATUS_SUCCESS))	// After 30ms it has failed.
	{
		SMSC_TRACE2(DBG_ERROR,"Timed out writing 0x%02x to EEPROM address 0x%03x\r\n", *pValue, Address);
		Status = NIC_STATUS_FAILURE;
	}
	else
	{
		SMSC_TRACE2(DBG_EEPROM,"Wrote 0x%02x to EEPROM address 0x%03x\r\n", *pValue, Address);
		Status = NIC_STATUS_SUCCESS;
	}

Exit_NICWriteEepromByte:
	SMSC_TRACE0(DBG_EEPROM,"<-- NICWriteEepromByte\r\n");
	return Status;
}



/*++

Routine Description:

	This routine reads a block of data from the EEPROM

Arguments:

	Adapter 	Pointer to our adapter
	Address		Byte offset into the EEPROM to read
	Length		Length in bytes to read
	pValue		Pointer to a byte location where the read data is returned

Return Value:

	NIC_STATUS.

--*/
NIC_STATUS
NICReadEepromBlock(
	IN PMP_ADAPTER Adapter,
	IN WORD Address,
	IN DWORD Length,
	OUT PBYTE pValue
	)

{
	NIC_STATUS Status = NIC_STATUS_SUCCESS;
	WORD i;
	SMSC_TRACE0(DBG_EEPROM,"--> NICReadEepromBlock\r\n");

	if (!Length)
	{
		SMSC_TRACE0(DBG_ERROR,"Invalid Length = 0, need to read one or more bytes\r\n");
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICReadEepromBlock;
	}

	if (Address & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM read byte starting address = %d > %d = max eeprom address \r\n", Address, 0x1ff);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICReadEepromBlock;
	}

	if ((Address + Length - 1) & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM read block requested since (address + length - 1) = %d > %d = max eeprom address\r\n", Address + Length, ETH_E2P_CMD_EPC_ADDR_);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICReadEepromBlock;
	}

	for (i=0; i<Length; i++)
	{
		
		if (NIC_STATUS_FAILURE == (Status = NICReadEepromByte(Adapter, Address + i, (PBYTE)(pValue+i))))
		{
			break;
		}
		
	}

	
Exit_NICReadEepromBlock:
	SMSC_TRACE0(DBG_EEPROM,"<-- NICReadEepromBlock\r\n");
	return Status;
}



/*++

Routine Description:

	This routine writes a block of data to the EEPROM

Arguments:

	Adapter 	Pointer to our adapter
	Address		Byte offset into the EEPROM to write to
	Length		Length in bytes to write
	pValue		Pointer to a byte location where the write data is located

Return Value:

	NIC_STATUS.

--*/
NIC_STATUS
NICWriteEepromBlock(
	IN PMP_ADAPTER Adapter,
	IN WORD Address,
	IN DWORD Length,
	IN PBYTE pValue
	)

{
	NIC_STATUS Status = NIC_STATUS_SUCCESS;
	WORD i;

	SMSC_TRACE0(DBG_EEPROM,"--> NICWriteEepromBlock\r\n");
	if (!Length)
	{
		SMSC_TRACE0(DBG_ERROR,"Invalid Length = 0, need to write one or more bytes\r\n");
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICWriteEepromBlock;
	}

	if (Address & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM write byte starting address = %d > %d = max eeprom address \r\n", Address, 0x1ff);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICWriteEepromBlock;
	}

	if ((Address + Length - 1) & (~ETH_E2P_CMD_EPC_ADDR_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM write block requested since (address + length - 1) = %d > %d = max eeprom address\r\n", Address + Length, ETH_E2P_CMD_EPC_ADDR_);
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICWriteEepromBlock;
	}

	for (i=0; i<Length ; i++)
	{
		if (NIC_STATUS_FAILURE == (Status = NICWriteEepromByte(Adapter, Address + i, (PBYTE)(pValue+i))))
		{
			break;
		}
	}

Exit_NICWriteEepromBlock:
	SMSC_TRACE0(DBG_EEPROM,"<-- NICWriteEepromBlock\r\n");
	return Status;
}


/*++

Routine Description:

	This routine perfroms a single command on the EEPROM

Arguments:

	Adapter 	Pointer to our adapter

Return Value:

	NIC_STATUS. Fails if it timesout.

--*/
NIC_STATUS
NICEepromCommand(
	IN PMP_ADAPTER Adapter,
	IN DWORD Command
	)

{
	DWORD Timeout = 0UL, Value32,dwTemp;
	NIC_STATUS Status = NIC_STATUS_SUCCESS;
	SMSC_TRACE0(DBG_EEPROM,"--> NICEepromCommand\r\n");
	
	if (Command & (~ETH_E2P_CMD_EPC_CMD_))
	{
		SMSC_TRACE2(DBG_ERROR,"Invalid EEPROM Command = 0x%08x has 0x%08x invalid bits set\r\n", Command, Command & (~ETH_E2P_CMD_EPC_CMD_));
		Status = NIC_STATUS_FAILURE;
		goto Exit_NICEepromCommand;
	}

	dwTemp= ETH_E2P_CMD_EPC_TIMEOUT_;
	Status = NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);	// Clear the timeout if it was set.
	if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICEepromCommand;

	// Program the command
	dwTemp=ETH_E2P_CMD_EPC_BUSY_ | Command;
	Status = NICWriteRegister(	Adapter,
						ETH_E2P_CMD,
						&dwTemp);
	
	if (Status != NIC_STATUS_SUCCESS)
				goto Exit_NICEepromCommand;

	while (Timeout++ <= 300)
	{
		Status = NICReadRegister(Adapter, ETH_E2P_CMD, &Value32);
		
		if (Status != NIC_STATUS_SUCCESS)
					break;
		
		if (Value32 & ETH_E2P_CMD_EPC_TIMEOUT_)		// Timed-out
		{
			Status = NIC_STATUS_FAILURE;
			break;
		}

		if (Value32 & ETH_E2P_CMD_EPC_BUSY_)			// Not done yet.
		{
			continue;
		}
		else
		{
			break;
		}
	}

	if ((Timeout > 300) || (Status != NIC_STATUS_SUCCESS))	// After 30ms it has failed.
	{
		SMSC_TRACE1(DBG_ERROR,"Timed out waiting for EEPROM Command 0x%x\r\n", Command);
		Status = NIC_STATUS_FAILURE;
	}
	else
	{
		SMSC_TRACE1(DBG_EEPROM,"EEPROM Command 0x%x completed\r\n", Command);
		Status = NIC_STATUS_SUCCESS;
	}

Exit_NICEepromCommand:
	SMSC_TRACE0(DBG_EEPROM,"--> NICReadEepromBlock\r\n");
	return Status;
}


/*++

Routine Description:

	This routine requests a reload of the EEPROM

Arguments:

	Adapter 	Pointer to our adapter

Return Value:

	NIC_STATUS. Success if operation completes and only if the Data loaded bit gets set

--*/
NIC_STATUS
NICEepromReload(
	IN PMP_ADAPTER Adapter
	)

{
	DWORD Timeout = 0UL, Value32,dwTemp;
	NIC_STATUS Status = NIC_STATUS_SUCCESS;
	SMSC_TRACE0(DBG_EEPROM,"--> NICEepromReload\r\n");
	
	dwTemp=ETH_E2P_CMD_EPC_TIMEOUT_;
	Status = NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);	// Clear the timeout if it was set.
	if (Status != NIC_STATUS_SUCCESS)
				goto Exit_NICEepromReload;

	dwTemp=ETH_E2P_CMD_E2P_PROG_DONE_;
	Status = NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);	// Clear the loaded if it was set.
	if (Status != NIC_STATUS_SUCCESS)
				goto Exit_NICEepromReload;

	// Program the reload command
	dwTemp=ETH_E2P_CMD_EPC_BUSY_ | ETH_E2P_CMD_E2P_PROG_DONE_;
	Status = NICWriteRegister(	Adapter,
						ETH_E2P_CMD,
						&dwTemp);
	if (Status != NIC_STATUS_SUCCESS)
				goto Exit_NICEepromReload;

	while (Timeout++ <= 300)
	{
		Status = NICReadRegister(Adapter, ETH_E2P_CMD, &Value32);
		if (Status != NIC_STATUS_SUCCESS)
				break;
		if (Value32 & ETH_E2P_CMD_EPC_TIMEOUT_)		// Timed-out
		{
			Status = NIC_STATUS_FAILURE;
			break;
		}

		if (Value32 & ETH_E2P_CMD_EPC_BUSY_)			// Not done yet.
		{
			continue;
		}
		else
		{
			break;
		}
	}

	if ((Timeout > 300) || (Status != NIC_STATUS_SUCCESS))	// After 30ms it has failed.
	{
		SMSC_TRACE0(DBG_ERROR,"Timed out reloading EEPROM\r\n");
		Status = NIC_STATUS_FAILURE;
	}
	else
	{
		Status = NICReadRegister(Adapter, ETH_E2P_CMD, &Value32);
		if (Status != NIC_STATUS_SUCCESS)
		{
			SMSC_TRACE0(DBG_ERROR, "Failed reading ETH_E2P_CMD to check LOADED bit after RELOAD completed\r\n");
		}
		else
		{
			if (!(Value32 & ETH_E2P_CMD_E2P_PROG_DONE_))
			{
				SMSC_TRACE0(DBG_ERROR, "Data loaded is not set after RELOAD completed \r\n");
				Status = NIC_STATUS_FAILURE;
			}
			else
			{
				dwTemp=ETH_E2P_CMD_E2P_PROG_DONE_;
				Status = NICWriteRegister(Adapter, ETH_E2P_CMD, &dwTemp);	// Clear the loaded if it was set.
				if (Status != NIC_STATUS_SUCCESS)
				{
					SMSC_TRACE0(DBG_ERROR,"Failed writing to clear LOADED bit in ETH_E2P_CMD after RELOAD completed (Reload completed ok anyway)\r\n");
				}
				SMSC_TRACE0(DBG_EEPROM,"EEPROM reload completed\r\n");
				Status = NIC_STATUS_SUCCESS;	// Reload completed anyway even is last write failed, so overwrite
			}
		}
	}
	
Exit_NICEepromReload:

SMSC_TRACE0(DBG_EEPROM,"--> NICEepromReload\r\n");
	return Status;
}


/*++

Routine Description:

    This routine reads VLAN part of the VHF RAM

Arguments:

    Adapter     - Pointer to our adapter
                - VLAN Offset
                - Pointer to VLAN Value

Return Value:

    NIC_STATUS. Success if operation completes

--*/
NIC_STATUS
NICReadVlanRam32(
    IN  PMP_ADAPTER Adapter, 
    IN  DWORD Offset, 
    OUT DWORD *pValue32)
{
    DWORD dwRamReady = 0, waitCount=0,Temp32;
    NIC_STATUS Status = NIC_STATUS_SUCCESS;
    
    // Select VHF RAM
    Temp32=ETH_DP_SEL_RSEL_VLAN_DA_;
    NICWriteRegister(Adapter, ETH_DP_SEL, &Temp32);
    
    // Check Offset range
    if ((ETH_DP_ADDR_MASK_ & Offset) < ETH_DA_HASH_BASE)
    {
    	Temp32=ETH_DP_ADDR_MASK_ & Offset;
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Temp32);
    }
    else
    {
        SMSC_TRACE0(DBG_E2PRAM,"Wrong address in NICReadVlanRam32, Set read value to 0\r\n");
        *pValue32 = 0UL;
        return NIC_STATUS_FAILURE;
    }
    
    // Set READ command
    Temp32=ETH_DP_CMD_READ_;
    NICWriteRegister(Adapter, ETH_DP_CMD, &Temp32);
	
    while(TRUE)
       {
        // Check ready bit
        NICReadRegister(Adapter, ETH_DP_SEL, &dwRamReady);
        if(!(dwRamReady & ETH_DP_SEL_DPRDY_))
        {
        	NdisMSleep(50);
            waitCount++;
        }
        else
        {
            NICReadRegister(Adapter, ETH_DP_DATA, pValue32);
            break;
        }
        
        // Don't wait more than 500 usec
        if (waitCount > 10)
        {
            SMSC_TRACE1(DBG_E2PRAM,"NICReadVlanRam32 failed after 500 usec, ETH_DP_SEL=0x%08lX\r\n", dwRamReady);
            Status = NIC_STATUS_FAILURE;
            break;
        }
    }
    
    return Status;
}



/*++

Routine Description:

    This routine writes into VLAN part of the VHF RAM

Arguments:

    Adapter     - Pointer to our adapter
                - VLAN Offset
                - VLAN Value

Return Value:

    NIC_STATUS. Success if operation completes

--*/
NIC_STATUS
NICWriteVlanRam32(
    IN  PMP_ADAPTER Adapter, 
    IN  DWORD Offset, 
    IN  DWORD Value32)
{
    DWORD dwRamReady, waitCount=0,Temp32;
    NIC_STATUS Status = NIC_STATUS_SUCCESS;
    
    // Select VHF RAM
    Temp32=ETH_DP_SEL_RSEL_VLAN_DA_;
    NICWriteRegister(Adapter, ETH_DP_SEL, &Temp32);

    // Check Offset range
    if ((ETH_DP_ADDR_MASK_ & Offset) < ETH_DA_HASH_BASE)
    {
        // Setup Address and Data
        Temp32=ETH_DP_ADDR_MASK_ & Offset;
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Temp32);
        NICWriteRegister(Adapter, ETH_DP_DATA, &Value32);

        // Set WRITE command
        Temp32=ETH_DP_CMD_WRITE_;
        NICWriteRegister(Adapter, ETH_DP_CMD, &Temp32);
        
        while(TRUE)
        {
            // Check ready bit
            NICReadRegister(Adapter, ETH_DP_SEL, &dwRamReady);
            if(!(dwRamReady & ETH_DP_SEL_DPRDY_))
            {
            	NdisMSleep(50);
                waitCount++;
            }
            else
            {
                break;
            }
            
            // Don't wait more than 500 usec
            if (waitCount > 10)
            {
                SMSC_TRACE1(DBG_E2PRAM,"NICWriteVlanRam32 failed after 500 usec, ETH_DP_SEL=0x%08lX\r\n", dwRamReady);
                Status = NIC_STATUS_FAILURE;
                break;
            }
        }
    }
    else
    {
        SMSC_TRACE0(DBG_E2PRAM,"Wrong address in NICWriteVlanRam32, no writing\r\n");
        Status = NIC_STATUS_FAILURE;
    }
    
    return Status;
}


/*++

Routine Description:

    This routine reads Hash table of the VHF RAM

Arguments:

    Adapter     - Pointer to our adapter
                - HASH Offset
                - Pointer to HASH Value

Return Value:

    NIC_STATUS. Success if operation completes

--*/
NIC_STATUS
NICReadHashRam32(
    IN  PMP_ADAPTER Adapter, 
    IN  DWORD Offset, 
    OUT DWORD *pValue32)
{
    DWORD dwRamReady, waitCount=0,Temp32;
    NIC_STATUS Status = NIC_STATUS_SUCCESS;
    
    // Select VHF RAM
    Temp32=ETH_DP_SEL_RSEL_VLAN_DA_;
    NICWriteRegister(Adapter, ETH_DP_SEL, &Temp32);

    // Check Offset range
    if ((ETH_DP_ADDR_MASK_ & Offset) < 16)
    {
    	Temp32=((ETH_DP_ADDR_MASK_ & Offset) + ETH_DA_HASH_BASE);
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Temp32);
    }
    else
    {
    	Temp32=ETH_DA_HASH_BASE;
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Temp32);
        SMSC_TRACE0(DBG_E2PRAM,"Wrong address in NICReadHashRam32, reading from address 0\r\n");
        Status = NIC_STATUS_FAILURE;
    }

    // Set READ command
    Temp32=ETH_DP_CMD_READ_;
    NICWriteRegister(Adapter, ETH_DP_CMD, &Temp32);
    
    while(TRUE)
    
    {
        // Check ready bit
        NICReadRegister(Adapter, ETH_DP_SEL, &dwRamReady);
        if(!(dwRamReady & ETH_DP_SEL_DPRDY_))
        {
        	NdisMSleep(50);
            waitCount++;
        }
        else
        {
            NICReadRegister(Adapter, ETH_DP_DATA, pValue32);
            break;
        }
        
        // Don't wait more than 500 usec
        if (waitCount > 10)
        {
            SMSC_TRACE1(DBG_E2PRAM,"NICReadHashRam32 failed after 500 usec, DP_SEL=0x%08lX\r\n", dwRamReady);
            Status = NIC_STATUS_FAILURE;
            break;
        }
    }

    return Status;
}



/*++

Routine Description:

    This routine writes into HASH table of the VHF RAM

Arguments:

    Adapter     - Pointer to our adapter
                - HASH Offset
                - HASH Value

Return Value:

    NIC_STATUS. Success if operation completes

--*/
NIC_STATUS
NICWriteHashRam32(
    IN  PMP_ADAPTER Adapter, 
    IN  DWORD Offset, 
    IN  DWORD Value32)
{
    DWORD dwRamReady, waitCount=0,Temp32;
    NIC_STATUS Status = NIC_STATUS_SUCCESS;
    
    // Select VHF RAM
    Temp32=ETH_DP_SEL_RSEL_VLAN_DA_;
    NICWriteRegister(Adapter, ETH_DP_SEL, &Temp32);

    // Check Offset range
    if ((ETH_DP_ADDR_MASK_ & Offset) < 16)
    {
        // Setup Address and Data
        Temp32=((ETH_DP_ADDR_MASK_ & Offset) + ETH_DA_HASH_BASE);
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Temp32);
        NICWriteRegister(Adapter, ETH_DP_DATA, &Value32);

        // Set WRITE command
        Temp32=ETH_DP_CMD_WRITE_;
        NICWriteRegister(Adapter, ETH_DP_CMD, &Temp32);
        while(TRUE)
        {
            // Check ready bit
            NICReadRegister(Adapter, ETH_DP_SEL, &dwRamReady);
            if(!(dwRamReady & ETH_DP_SEL_DPRDY_))
            {
                waitCount++;
                NdisMSleep(50);
            }
            else
            {
                break;
            }
            
            // Don't wait more than 500 usec
            if (waitCount > 10)
            {
                SMSC_TRACE1(DBG_E2PRAM,"NICWriteHashRam32 failed after 500 usec, DP_SEL=0x%08lX\r\n", dwRamReady);
                Status = NIC_STATUS_FAILURE;
                break;
            }
        }
    }
    else
    {
        SMSC_TRACE0(DBG_E2PRAM,"Wrong address in NICWriteHashRam32, no writing\r\n");
        Status = NIC_STATUS_FAILURE;
    }

    return Status;
}



/*++

Routine Description:

    This routine reads WoL packet bytes of the WoL FIFO

Arguments:

    Adapter     - Pointer to our adapter
                - Offset
                - Pointer to WoL Packet Byte

Return Value:

    NIC_STATUS. Success if operation completes

--*/
NIC_STATUS
NICReadWolRam32(
    IN  PMP_ADAPTER Adapter, 
    IN  DWORD Offset, 
    OUT DWORD *pValue32)
{
    DWORD dwRamReady = 0, waitCount=0,Value32;
    NIC_STATUS Status = NIC_STATUS_SUCCESS;
    
    // Select VHF RAM
    Value32=ETH_DP_SEL_RSEL_WOL_RAM_;
    NICWriteRegister(Adapter, ETH_DP_SEL, &Value32);
    
    // Check Offset range
    if ((ETH_DP_ADDR_MASK_ & Offset) < ETH_WOL_FIFO_SIZE)
    {
    	Value32=ETH_DP_ADDR_MASK_ & Offset;
        NICWriteRegister(Adapter, ETH_DP_ADDR, &Value32);
    }
    else
    {
        SMSC_TRACE0(DBG_E2PRAM,"Wrong address in NICReadVlanRam32, Set read value to 0\r\n");
        *pValue32 = 0UL;
        return NIC_STATUS_FAILURE;
    }
    
    // Set READ command
    Value32=ETH_DP_CMD_READ_;
    NICWriteRegister(Adapter, ETH_DP_CMD, &Value32);
    
    while(TRUE)
    
    {
        // Check ready bit
        NICReadRegister(Adapter, ETH_DP_SEL, &dwRamReady);
        if(!(dwRamReady & ETH_DP_SEL_DPRDY_))
        {
            waitCount++;
            NdisMSleep(50);
        }
        else
        {
            NICReadRegister(Adapter, ETH_DP_DATA, pValue32);
            break;
        }
        
        // Don't wait more than 500 usec
        if (waitCount > 10)
        {
            SMSC_TRACE1(DBG_E2PRAM,"NICReadVlanRam32 failed after 500 usec, ETH_DP_SEL=0x%08lX\r\n", dwRamReady);
            Status = NIC_STATUS_FAILURE;
            break;
        }
    }
    
    return Status;
}


#ifdef USE_THREAD


DWORD RecvThread(
		LPVOID Context
		)
{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;


   SMSC_TRACE0(DBG_INIT,"--->RecvThread\r\n");

   SMSC_TRACE1(DBG_INIT,"--->RecvThread, Pri:%d \r\n",
		CeGetThreadPriority(GetCurrentThread()));

   while(!pDevice->RecvThreadExitFlag){


	   WaitForSingleObject(pDevice->RecvThreadEvent, INFINITE);
	   ResetEvent(pDevice->RecvThreadEvent);	   
	   BulkInCompletionCallBack(pDevice);

   }

   SMSC_TRACE0(DBG_INIT,"<---RecvThread\r\n");
   ExitThread(ERROR_SUCCESS);

   return ERROR_SUCCESS;
}


DWORD SendThread(
		LPVOID Context
		)
{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;

   SMSC_TRACE0(DBG_INIT,"--->SendThread\r\n");

 SMSC_TRACE1(DBG_INIT,"--->SendThread, Pri:%d \r\n",
		CeGetThreadPriority(GetCurrentThread()));

   while(!pDevice->SendThreadExitFlag){
	   WaitForSingleObject(pDevice->SendThreadEvent, INFINITE);
	   ResetEvent(pDevice->SendThreadEvent);

	   SendsCompletionCallBack(pDevice);
   }

   SMSC_TRACE0(DBG_INIT,"<---SendThread\r\n");
   ExitThread(ERROR_SUCCESS);

   return ERROR_SUCCESS;
}

#endif

#ifdef USE_WORK_ITEM_NO_OUT

DWORD RecvWorkItemCallBack(
		PNDIS_WORK_ITEM WorkItem, 
		PVOID Context
		)
{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;


   SMSC_TRACE0(DBG_INIT,"--->RecvWorkItemCallBack\r\n");


   while(!pDevice->RecvWorkItemExitFlag){


	   NdisWaitEvent(&pDevice->RecvWorkItemReady, 0);
	   NdisResetEvent(&pDevice->RecvWorkItemReady);	   
	   BulkInCompletionCallBack(pDevice);

   }

   SMSC_TRACE0(DBG_INIT,"<---RecvWorkItemCallBack\r\n");

   return ERROR_SUCCESS;
}

DWORD SendWorkItemCallBack(
		PNDIS_WORK_ITEM WorkItem, 
		PVOID Context
		)

{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;

   SMSC_TRACE0(DBG_INIT,"--->SendWorkItemCallBack\r\n");

 
   while(!pDevice->SendWorkItemExitFlag){
	   NdisWaitEvent(&pDevice->SendWorkItemReady, 0);
	   NdisResetEvent(&pDevice->SendWorkItemReady);

	   // Now process all the RCBs we've collected in the wait list
	   SendsCompletionCallBack(pDevice);
   }

   SMSC_TRACE0(DBG_INIT,"<---SendWorkItemCallBack\r\n");
   
   return ERROR_SUCCESS;
}

#endif

#ifdef USE_INT_PIPE
#ifdef USE_THREAD

DWORD IntThread(
		LPVOID Context
		)
{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;

   SMSC_TRACE0(DBG_INIT,"--->IntThread\r\n");

 SMSC_TRACE1(DBG_INIT,"--->IntThread, Pri:%d \r\n",
		CeGetThreadPriority(GetCurrentThread()));

   while(!pDevice->IntThreadExitFlag) {
	   WaitForSingleObject(pDevice->IntThreadEvent, INFINITE);
	   ResetEvent(pDevice->IntThreadEvent);
	   
	   IntsCompletionCallBack(pDevice);
   }

   SMSC_TRACE0(DBG_INIT,"<---IntThread\r\n");
   ExitThread(ERROR_SUCCESS);

   return ERROR_SUCCESS;
}

#endif

#ifdef USE_WORK_ITEM_NO_OUT

DWORD IntWorkItemCallback(
		PNDIS_WORK_ITEM WorkItem, 
		PVOID Context
		)
{
   PMP_ADAPTER pDevice = (PMP_ADAPTER)Context;

   SMSC_TRACE0(DBG_INIT,"--->IntWorkItemCallback\r\n");

 
   while(!pDevice->IntWorkItemExitFlag) {
	   NdisWaitEvent(&pDevice->IntsWorkItemReady, 0);
	   NdisResetEvent(&pDevice->IntsWorkItemReady);
	   
	   IntsCompletionCallBack(pDevice);
   }

   SMSC_TRACE0(DBG_INIT,"<---IntWorkItemCallback\r\n");
   
   return ERROR_SUCCESS;
}

#endif
#endif

void GetDriverInfo()
{
	SMSC_TRACE0(DBG_INIT,"SMSC: LAN7500 USB 2.0 to Ethernet 10/100 Driver. \r\n");
	SMSC_TRACE4(DBG_INIT,"SMSC: DRIVER_VERSION : V%d.%d.%04d.%04d\r\n", 
				DRIVER_MAJOR_VERSION,
				DRIVER_MINOR_VERSION,
				DRIVER_BUILD_VERSION,
				DRIVER_QFE_VERSION);
	SMSC_TRACE1(DBG_INIT,"SMSC: DATECODE : %s \r\n", TEXT(DATE_CODE));
	SMSC_TRACE2(DBG_INIT,"SMSC: Built on %s at %s \r\n", TEXT(__DATE__), TEXT(__TIME__));
}

void PrnPackect(UCHAR * packet, UINT len)
{
	UINT i;
  UCHAR * p=packet;
  
  RETAILMSG(1,(TEXT("len=  %d \r\n"),len));
  for (i=0; i<len; i++) {
	if ((i%16)==0)
		RETAILMSG(1,(TEXT("\r\n")));
	RETAILMSG(1,(TEXT(" %02x"),*(p+i)));
	
}
  RETAILMSG(1,(TEXT("\r\n")));

}


VOID
NICDisplayWakePacket(
    IN PMP_ADAPTER Adapter)
{
    DWORD Value32;
    DWORD i, WolPacketLength = 0;
    
    // Check WOL FIFO Status Reg.
    NICReadRegister(Adapter, ETH_WOL_FIFO_STS, &Value32);
    if (!Value32) // No WoL Packet
    {
        return;
    }
    
    if (Value32 & ETH_WOL_FIFO_STS_WOL_FIFO_OVFL_)
    {
        SMSC_TRACE0(DBG_E2PRAM,"\nWoL FIFO Overflow!!!\r\n");
        WolPacketLength = (256UL/4);
        SMSC_TRACE0(DBG_E2PRAM,"\nWoL Packet: (Length = 256 bytes)\r\n");
    }
    else
    {
        WolPacketLength = ((Value32 & ETH_WOL_FIFO_STS_WOL_FIFO_CNT_)/4);
        SMSC_TRACE1(DBG_E2PRAM,"\nWoL Packet: (Length = %d bytes)\n", (Value32 & ETH_WOL_FIFO_STS_WOL_FIFO_CNT_));
    }
    
    for (i=0; i<WolPacketLength; i++)
    {
        
        if (NIC_STATUS_SUCCESS == NICReadWolRam32(Adapter, i, &Value32))
        {
            if (i && !(i%4))
            {
                SMSC_TRACE0(DBG_E2PRAM,"\r\n");
            }

            SMSC_TRACE4(DBG_E2PRAM,"%02lX  %02lX  %02lX  %02lX  ", (Value32&0xFFUL), 
                                                                        ((Value32&0xFF00UL)>>8),
                                                                        ((Value32&0xFF0000UL)>>16),
                                                                        ((Value32&0xFF000000UL)>>24));
        }
    }
       
    SMSC_TRACE0(DBG_E2PRAM,"\r\n"); 
}



/*
NIC_STATUS
NICSetGpo(
	IN PMP_ADAPTER Adapter,
	IN DWORD Gpo,
	IN DWORD State
	)
	*/
/*++

Routine Description:

	This routine set/reset General Purpose Output.

Arguments:

	Adapter - pointer to our Adapter
	Gpo - Gpo [0:10]
	State - 1 = ON or 0 = OFF

Return Value:

	NIC_STATUS
--*/
/*
{
	NIC_STATUS Status = NIC_STATUS_FAILURE;
	DWORD Value32;
	
	if ((Gpo > 10) || (State > 1))
	{
		if (State > 1)
		{
			SMSC_TRACE2(DBG_ERROR, "Gpo%d state (%d) is out of range [0:1] in NICSetGpo\r\n", Gpo, State);
		}
		
		goto Exit_NICSetGpo;
	}
	
	
	// Check output polarity
	if (!Adapter->LinkLedOnGpioPolarity) // Active low output
	{
		State ^= 0x1; // Invert State
	}
	
	if (Gpo < 8)
	{
		Status = NICReadRegister( Adapter, ETH_GPIO_CFG, &Value32 );
		if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICSetGpo;
			
		Value32 &= (~(ETH_GPIO_CFG_GPO0_DATA_ << Gpo));
		Value32 |= (State << Gpo);

		Status = NICWriteRegister( Adapter, ETH_GPIO_CFG, &Value32 );
		if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICSetGpo;

		Status = NICReadRegister( Adapter, ETH_GPIO_CFG, &Value32);
		SMSC_TRACE1(DBG_RESET,"in NicSetGpo, ETH_GPIO_CFG = 0x%x \r\n",Value32);
	}
	else
	{
		Status = NICReadRegister( Adapter, ETH_LED_GPIO_CFG, &Value32 );
		if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICSetGpo;
			
		Value32 &= (~(ETH_LED_GPIO_CFG_GPDATA_08_ << (Gpo-8)));
		Value32 |= (State << (Gpo-8));

		Status = NICWriteRegister( Adapter, ETH_LED_GPIO_CFG, &Value32 );
		if (Status != NIC_STATUS_SUCCESS)
			goto Exit_NICSetGpo;
		Status = NICReadRegister( Adapter, ETH_LED_GPIO_CFG, &Value32);
		SMSC_TRACE1(DBG_RESET,"in NicSetGpo, ETH_LED_GPIO_CFG = 0x%x \r\n",Value32);
	}

Exit_NICSetGpo:
	
	return Status;
}

*/

//EOF
